/*	$NetBSD$	*/
/*	$NecBSD: isavar.h,v 1.34 1999/07/23 05:41:40 kmatsuda Exp $	*/
/*	$NetBSD/i386: isavar.h,v 1.37 1999/03/19 05:13:18 cgd Exp $	*/

/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 1994, 1995, 1996, 1997, 1998
 *	NetBSD/pc98 porting staff. All rights reserved.
 */

/*-
 * Copyright (c) 1997 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Jason R. Thorpe of the Numerical Aerospace Simulation Facility,
 * NASA Ames Research Center.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the NetBSD
 *	Foundation, Inc. and its contributors.
 * 4. Neither the name of The NetBSD Foundation nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * Copyright (c) 1995 Chris G. Demetriou
 * Copyright (c) 1992 Berkeley Software Design, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Berkeley Software
 *	Design, Inc.
 * 4. The name of Berkeley Software Design must not be used to endorse
 *    or promote products derived from this software without specific
 *    prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY BERKELEY SOFTWARE DESIGN, INC. ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL BERKELEY SOFTWARE DESIGN, INC. BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	BSDI Id: isavar.h,v 1.5 1992/12/01 18:06:00 karels Exp 
 */

#ifndef _PC98_CBUSVAR_H_
#define	_PC98_CBUSVAR_H_

/*
 * Definitions for CBus autoconfiguration.
 */

#include <sys/device.h>
#include <sys/queue.h>
#include <machine/bus.h>

#include <pc98/cbus/cbusdmavar.h>

/*
 * Types provided to CBus code.
 */
struct pc98_cbus_chipset {
        struct cbus_dma_state cc_dmastate;
};

typedef struct pc98_cbus_chipset *cbus_chipset_tag_t;

/* 
 * Structures and definitions needed by the machine-dependent header.
 */

struct device;                  /* XXX */
struct neccbus_attach_args;	/* XXX */

/*
 * Functions provided to CBus code.
 */
void	cbus_attach_hook __P((struct device *, struct device *,
	    struct neccbus_attach_args *));
int	cbus_intr_alloc __P((cbus_chipset_tag_t, int, int, int *));
void	*cbus_intr_establish __P((cbus_chipset_tag_t ic, int irq, int type,
	    int level, int (*ih_fun)(void *), void *ih_arg));
void	cbus_intr_disestablish __P((cbus_chipset_tag_t ic, void *handler));
int	cbus_mem_alloc __P((bus_space_tag_t, bus_size_t, bus_size_t,
	    bus_addr_t, int, bus_addr_t *, bus_space_handle_t *));
void	cbus_mem_free __P((bus_space_tag_t, bus_space_handle_t, bus_size_t));

#define	cbus_dmainit(cc, bst, dmat, d)					\
	_cbus_dmainit(&(cc)->cc_dmastate, (bst), (dmat), (d))
#define	cbus_dmacascade(cc, c)						\
	_cbus_dmacascade(&(cc)->cc_dmastate, (c))
#define	cbus_dmamap_create(cc, c, s, f)					\
	_cbus_dmamap_create(&(cc)->cc_dmastate, (c), (s), (f))
#define	cbus_dmamap_destroy(cc, c)					\
	_cbus_dmamap_destroy(&(cc)->cc_dmastate, (c))
#define	cbus_dmastart(cc, c, a, n, p, f, bf)				\
	_cbus_dmastart(&(cc)->cc_dmastate, (c), (a), (n), (p), (f), (bf))
#define	cbus_dmaabort(cc, c)						\
	_cbus_dmaabort(&(cc)->cc_dmastate, (c))
#define	cbus_dmacount(cc, c)						\
	_cbus_dmacount(&(cc)->cc_dmastate, (c))
#define	cbus_dmafinished(cc, c)						\
	_cbus_dmafinished(&(cc)->cc_dmastate, (c))
#define	cbus_dmadone(cc, c)						\
	_cbus_dmadone(&(cc)->cc_dmastate, (c))
#define	cbus_dmafreeze(cc)						\
	_cbus_dmafreeze(&(cc)->cc_dmastate)
#define	cbus_dmathaw(cc)						\
	_cbus_dmathaw(&(cc)->cc_dmastate)
#define	cbus_dmamem_alloc(cc, c, s, ap, f)				\
	_cbus_dmamem_alloc(&(cc)->cc_dmastate, (c), (s), (ap), (f))
#define	cbus_dmamem_free(cc, c, a, s)					\
	_cbus_dmamem_free(&(cc)->cc_dmastate, (c), (a), (s))
#define	cbus_dmamem_map(cc, c, a, s, kp, f)				\
	_cbus_dmamem_map(&(cc)->cc_dmastate, (c), (a), (s), (kp), (f))
#define	cbus_dmamem_unmap(cc, c, k, s)					\
	_cbus_dmamem_unmap(&(cc)->cc_dmastate, (c), (k), (s))
#define	cbus_dmamem_mmap(cc, c, a, s, o, p, f)				\
	_cbus_dmamem_mmap(&(cc)->cc_dmastate, (c), (a), (s), (o), (p), (f))
#define	cbus_drq_isfree(cc, c)						\
	_cbus_drq_isfree(&(cc)->cc_dmastate, (c))
#define	cbus_malloc(cc, c, s, p, f)					\
	_cbus_malloc(&(cc)->cc_dmastate, (c), (s), (p), (f))
#define	cbus_free(a, p)							\
	_cbus_free((a), (p))
#define	cbus_mappage(m, o, p)						\
	_cbus_mappage((m), (o), (p))

/*
 * ALL OF THE FOLLOWING ARE MACHINE-DEPENDENT, AND SHOULD NOT BE USED
 * BY PORTABLE CODE.
 */

extern struct pc98_bus_dma_tag cbus_bus_dma_tag;

/*
 * Cookie used by CBus DMA.  A pointer to one of these it stashed in
 * the DMA map.
 */
struct i386_cbus_dma_cookie {
	int	id_flags;		/* flags; see below */

	/*
	 * Information about the original buffer used during
	 * DMA map syncs.  Note that origibuflen is only used
	 * for ID_BUFTYPE_LINEAR.
	 */
	void	*id_origbuf;		/* pointer to orig buffer if
					   bouncing */
	bus_size_t id_origbuflen;	/* ...and size */
	int	id_buftype;		/* type of buffer */

	void	*id_bouncebuf;		/* pointer to the bounce buffer */
	bus_size_t id_bouncebuflen;	/* ...and size */
	int	id_nbouncesegs;		/* number of valid bounce segs */
	bus_dma_segment_t id_bouncesegs[0]; /* array of bounce buffer
					       physical memory segments */
};

/* id_flags */
#define	ID_MIGHT_NEED_BOUNCE	0x01	/* map could need bounce buffers */
#define	ID_HAS_BOUNCE		0x02	/* map currently has bounce buffers */
#define	ID_IS_BOUNCING		0x04	/* map is bouncing current xfer */

/* id_buftype */
#define	ID_BUFTYPE_INVALID	0
#define	ID_BUFTYPE_LINEAR	1
#define	ID_BUFTYPE_MBUF		2
#define	ID_BUFTYPE_UIO		3
#define	ID_BUFTYPE_RAW		4

/*
 * XXX Various seemingly PC-specific constants, some of which may be
 * unnecessary anyway.
 */

/*
 * RAM Physical Address Space (ignoring the above mentioned "hole")
 */
#define	RAM_BEGIN	0x0000000	/* Start of RAM Memory */
#define	RAM_END		0x1000000	/* End of RAM Memory */
#define	RAM_SIZE	(RAM_END - RAM_BEGIN)


/*
 * CBus DMA bounce buffers.
 * XXX should be made partially machine- and bus-mapping-independent.
 *
 * DMA_BOUNCE is the number of pages of low-addressed physical memory
 * to acquire for CBus bounce buffers.
 *
 * cbusphysmem is the location of those bounce buffers.  (They are currently
 * assumed to be contiguous.
 */

#ifndef DMA_BOUNCE
#define	DMA_BOUNCE      8		/* one buffer per channel */
#endif

extern vaddr_t cbusphysmem;


/*
 * Variables and macros to deal with the CBus I/O hole.
 * XXX These should be converted to machine- and bus-mapping-independent
 * function definitions, invoked through the softc.
 */

extern u_long atdevbase;           /* kernel virtual address of "hole" */

/*
 * Given a kernel virtual address for some location
 * in the "hole" I/O space, return a physical address.
 */
#define CBUS_PHYSADDR(v) ((void *) ((u_long)(v) - atdevbase + IOM_BEGIN))

/*
 * Given a physical address in the "hole",
 * return a kernel virtual address.
 */
#define CBUS_HOLE_VADDR(p)  ((void *) ((u_long)(p) - IOM_BEGIN + atdevbase))


/*
 * Miscellanous functions.
 */
void sysbeep __P((int, int));		/* beep with the system speaker */


/*
 * CBus attach arguments
 */
struct neccbus_attach_args {
	char	*cba_busname;		/* XXX should be common */
	bus_space_tag_t cba_iot;	/* i/o space tag */
	bus_space_tag_t cba_memt;	/* mem space tag */
	bus_dma_tag_t cba_dmat;		/* DMA tag */
	cbus_chipset_tag_t cba_ic;
};

/*
 * CBus driver attach arguments
 */
struct cbus_attach_args {
	bus_space_tag_t ca_iot;		/* i/o space tag */
	bus_space_tag_t ca_memt;	/* mem space tag */
	bus_dma_tag_t ca_dmat;		/* DMA tag */

	cbus_chipset_tag_t ca_ic;

	int	ca_iobase;		/* base i/o address */
#define	ca_ioaddr	ca_iobase
	int	ca_iosize;		/* span of ports used */
	int	ca_irq;			/* interrupt request */
	int	ca_drq;			/* DMA request */
	int	ca_drq2;		/* second DMA request */
	int	ca_maddr;		/* physical i/o mem addr */
	u_int	ca_msize;		/* size of i/o memory */
	void	*ca_aux;		/* driver specific */
	u_int	ca_cfgflags;		/* flags */
};

#include "locators.h"

#define	IOBASEUNK	CBUSCF_PORT_DEFAULT	/* i/o address is unknown */
#define	IRQUNK		CBUSCF_IRQ_DEFAULT	/* interrupt request line is unknown */
#define	DRQUNK		CBUSCF_DRQ_DEFAULT	/* DMA request line is unknown */
#define	MADDRUNK	CBUSCF_IOMEM_DEFAULT	/* shared memory address is unknown */

/*
 * ISA master bus
 */
struct cbus_softc {
	struct device sc_dev;		/* base device */

	bus_space_tag_t sc_iot;		/* io space tag */
	bus_space_tag_t sc_memt;	/* mem space tag */
	bus_dma_tag_t sc_dmat;		/* DMA tag */

	cbus_chipset_tag_t sc_ic;
};

#define		cf_iobase		cf_loc[CBUSCF_PORT]
#define		cf_iosize		cf_loc[CBUSCF_SIZE]
#define		cf_maddr		cf_loc[CBUSCF_IOMEM]
#define		cf_msize		cf_loc[CBUSCF_IOSIZ]
#define		cf_irq			cf_loc[CBUSCF_IRQ]
#define		cf_drq			cf_loc[CBUSCF_DRQ]
#define		cf_drq2			cf_loc[CBUSCF_DRQ2]

/*
 * ISA interrupt handler manipulation.
 * 
 * To establish an ISA interrupt handler, a driver calls cbus_intr_establish()
 * with the interrupt number, type, level, function, and function argument of
 * the interrupt it wants to handle.  Isa_intr_establish() returns an opaque
 * handle to an event descriptor if it succeeds, and returns NULL on failure.
 * (XXX: some drivers can't handle this, since the former behaviour was to
 * invoke panic() on failure). When the system does not accept any of the
 * interrupt types supported by the driver, the driver should fail the attach.
 * Interrupt handlers should return 0 for "interrupt not for me", 1  for
 * "I took care of it", or -1 for "I guess it was mine, but I wasn't
 * expecting it."
 *
 * To remove an interrupt handler, the driver calls cbus_intr_disestablish() 
 * with the handle returned by cbus_intr_establish() for that handler.
 */

/* ISA interrupt sharing types */
char	*cbus_intr_typename __P((int type));

/*
 * Some ISA devices (e.g. on a VLB) can perform 32-bit DMA.  This
 * flag is passed to bus_dmamap_create() to indicate that fact.
 */
#define	CBUS_DMA_32BIT	BUS_DMA_BUS1

#endif /* _PC98_CBUSVAR_H_ */
