#include "opt_config.h"

/*
 * Add either (or both) of
 *
 *	options INCLUDE_CONFIG_FILE
 *	options INCLUDE_JUST_CONFIG
 *
 * to your kernel config file to embed it in the resulting
 * kernel.  The latter option does not include files that are
 * included (recursively) by your config file.  The embedded
 * data be extracted by using the command:
 *
 *	strings netbsd | sed -n 's/^_CFG_//p' | unvis
 */

#ifdef CONFIG_FILE
#if defined(INCLUDE_CONFIG_FILE) || defined(INCLUDE_JUST_CONFIG)

static const char config[] __attribute__((__unused__)) =

#ifdef INCLUDE_CONFIG_FILE

"_CFG_### START CONFIG FILE \"YOTSUHA\"\n"

#endif /* INCLUDE_CONFIG_FILE */

"_CFG_#\\011$NetBSD$\n"
"_CFG_#\n"
"_CFG_\n"
"_CFG_include \"arch/pc98/conf/std.pc98\"\n"
"_CFG_\n"
"_CFG_maxusers\\01116\\011\\011# estimated number of users\n"
"_CFG_\n"
"_CFG_# CPU support.  At least one is REQUIRED.\n"
"_CFG_#options \\011I386_CPU\n"
"_CFG_#options \\011I486_CPU\n"
"_CFG_options \\011I586_CPU\n"
"_CFG_#options \\011I686_CPU\n"
"_CFG_\n"
"_CFG_# CPU-related options.\n"
"_CFG_#options \\011MATH_EMULATE\\011# floating point emulation\n"
"_CFG_#options \\011VM86\\011\\011# virtual 8086 emulation\n"
"_CFG_#options \\011USER_LDT\\011# user-settable LDT; used by WINE\n"
"_CFG_# eliminate delay no-ops in I/O; recommended on all but very old machines\n"
"_CFG_#options \\011DUMMY_NOPS\n"
"_CFG_\n"
"_CFG_options \\011UCONSOLE\\011# users can use TIOCCONS (for xconsole)\n"
"_CFG_options \\011INSECURE\\011# disable kernel security levels\n"
"_CFG_options \\011XSERVER\\011\\011# X server support in console drivers\n"
"_CFG_\n"
"_CFG_options \\011RTC_OFFSET=-540\\011# hardware clock is this many mins. west of GMT\n"
"_CFG_\n"
"_CFG_options \\011KTRACE\\011\\011# system call tracing via ktrace(1)\n"
"_CFG_options \\011SYSTRACE\\011# system call vetting via systrace(1)\n"
"_CFG_\n"
"_CFG_options \\011SYSVMSG         # System V-like message queues\n"
"_CFG_options \\011SYSVSEM         # System V-like semaphores\n"
"_CFG_#options \\011SEMMNI=10       # number of semaphore identifiers\n"
"_CFG_#options \\011SEMMNS=60       # number of semaphores in system\n"
"_CFG_#options \\011SEMUME=10       # max number of undo entries per process\n"
"_CFG_#options \\011SEMMNU=30       # number of undo structures in system\n"
"_CFG_options \\011SYSVSHM         # System V-like memory sharing\n"
"_CFG_options \\011SHMMAXPGS=8192  # 2048 pages is the default\n"
"_CFG_\n"
"_CFG_options \\011DIAGNOSTIC\\011# expensive kernel consistency checks\n"
"_CFG_options \\011DEBUG\\011\\011# expensive debugging checks/support\n"
"_CFG_options \\011DDB\\011\\011# in-kernel debugger\n"
"_CFG_options \\011DDB_ONPANIC=1\\011# see also sysctl(8): `ddb.onpanic'\n"
"_CFG_options \\011DDB_HISTORY_SIZE=512\\011# enable history editing in DDB\n"
"_CFG_\n"
"_CFG_options \\011COMPAT_13\\011# NetBSD 1.3,\n"
"_CFG_options \\011COMPAT_14\\011# NetBSD 1.4,\n"
"_CFG_options \\011COMPAT_15\\011# NetBSD 1.5,\n"
"_CFG_options \\011COMPAT_43\\011# and 4.3BSD\n"
"_CFG_\n"
"_CFG_#options \\011COMPAT_OLDBOOT\n"
"_CFG_\n"
"_CFG_# File systems\n"
"_CFG_file-system \\011FFS\\011\\011# UFS\n"
"_CFG_file-system \\011MFS\\011\\011# memory file system\n"
"_CFG_file-system \\011NFS\\011\\011# Network File System client\n"
"_CFG_file-system \\011CD9660\\011\\011# ISO 9660 + Rock Ridge file system\n"
"_CFG_file-system \\011MSDOSFS\\011\\011# MS-DOS file system\n"
"_CFG_file-system \\011KERNFS\\011\\011# /kern\n"
"_CFG_#file-system \\011NULLFS\\011\\011# loopback file system\n"
"_CFG_file-system \\011PROCFS\\011\\011# /proc\n"
"_CFG_\n"
"_CFG_# Networking options\n"
"_CFG_options \\011INET\\011\\011# IP + ICMP + TCP + UDP\n"
"_CFG_\n"
"_CFG_# These options enable verbose messages for several subsystems.\n"
"_CFG_# Warning, these may compile large string tables into the kernel!\n"
"_CFG_#options \\011MIIVERBOSE\\011# verbose PHY autoconfig messages\n"
"_CFG_options \\011PCIVERBOSE\\011# verbose PCI device autoconfig messages\n"
"_CFG_#options \\011PCI_CONFIG_DUMP\\011# verbosely dump PCI config space\n"
"_CFG_#options \\011PCMCIAVERBOSE\\011# verbose PCMCIA configuration messages\n"
"_CFG_#options \\011SCSIVERBOSE\\011# human readable SCSI error messages\n"
"_CFG_#options \\011USBVERBOSE\\011# verbose USB device autoconfig messages\n"
"_CFG_#options \\011I2OVERBOSE\\011# verbose I2O driver messages\n"
"_CFG_\n"
"_CFG_options \\011NFS_BOOT_DHCP,NFS_BOOT_BOOTPARAM,NFS_BOOT_BOOTP\n"
"_CFG_\n"
"_CFG_# Kernel root file system and dump configuration.\n"
"_CFG_config\\011\\011netbsd\\011root on ? type ?\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_#\n"
"_CFG_# Device configuration\n"
"_CFG_#\n"
"_CFG_\n"
"_CFG_mainbus0 at root\n"
"_CFG_\n"
"_CFG_cpu* at mainbus?\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Basic Bus Support\n"
"_CFG_\n"
"_CFG_# PCI bus support\n"
"_CFG_pci*\\011at mainbus? bus ?\n"
"_CFG_pci*\\011at pchb? bus ?\n"
"_CFG_pci*\\011at ppb? bus ?\n"
"_CFG_\n"
"_CFG_# PCI bridges\n"
"_CFG_pchb*\\011at pci? dev ? function ?\\011# PCI-Host bridges\n"
"_CFG_pccb*\\011at pci? dev ? function ?\\011# PCI-CBus bridges\n"
"_CFG_ppb*\\011at pci? dev ? function ?\\011# PCI-PCI bridges\n"
"_CFG_# XXX 'puc's aren't really bridges, but there's no better place for them here\n"
"_CFG_puc*\\011at pci? dev ? function ?\\011# PCI \"universal\" comm. cards\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# CBus support\n"
"_CFG_cbus*\\011at mainbus?\n"
"_CFG_cbus*\\011at pccb?\n"
"_CFG_\n"
"_CFG_# PCMCIA bus support\n"
"_CFG_pcmcia* at pcic? controller ? socket ?\n"
"_CFG_\n"
"_CFG_# CBus PCMCIA controllers\n"
"_CFG_pcic0\\011at cbus? port 0x3e0 iomem 0xc0000 iosiz 0x2000\n"
"_CFG_\n"
"_CFG_options \\011PCIC_CBUS_INTR_ALLOC_MASK=0x1028\n"
"_CFG_\n"
"_CFG_# Coprocessor Support\n"
"_CFG_\n"
"_CFG_# Math Coprocessor support\n"
"_CFG_npx0\\011at cbus? port 0xf8 irq 14\\011# x86 math coprocessor\n"
"_CFG_\n"
"_CFG_# Console Devices\n"
"_CFG_\n"
"_CFG_# You can only configure one of these!\n"
"_CFG_pc0\\011at cbus? port 0x41 irq 1\\011# generic console device\n"
"_CFG_\n"
"_CFG_# Serial Devices\n"
"_CFG_\n"
"_CFG_# CBus serial interfaces\n"
"_CFG_#ser0\\011at cbus? port 0x30 irq 4\\011# Internal 1st serial ports\n"
"_CFG_\n"
"_CFG_#seri*\\011at ser? slave?\n"
"_CFG_\n"
"_CFG_#sertty*\\011at seri?\n"
"_CFG_\n"
"_CFG_# IDE and related devices\n"
"_CFG_\n"
"_CFG_# PCI IDE controllers - see pciide(4) for supported hardware.\n"
"_CFG_# The 0x0001 flag force the driver to use DMA, even if the driver doesn't know\n"
"_CFG_# how to set up DMA modes for this chip. This may work, or may cause\n"
"_CFG_# a machine hang with some controllers.\n"
"_CFG_#pciide* at pci? dev ? function ? flags 0x0000\n"
"_CFG_\n"
"_CFG_# PCMCIA IDE controllers\n"
"_CFG_wdc*\\011at pcmcia? function ?\n"
"_CFG_\n"
"_CFG_# CBus IDE controllers\n"
"_CFG_wdc0\\011at cbus? port 0x640 irq 9\n"
"_CFG_\n"
"_CFG_# IDE drives\n"
"_CFG_# Flags are used only with controllers that support DMA operations\n"
"_CFG_# and mode settings (e.g. some pciide controllers)\n"
"_CFG_# The lowest order four bits (rightmost digit) of the flags define the PIO\n"
"_CFG_# mode to use, the next set of four bits the DMA mode and the third set the\n"
"_CFG_# UltraDMA mode. For each set of four bits, the 3 lower bits define the mode\n"
"_CFG_# to use, and the last bit must be 1 for this setting to be used.\n"
"_CFG_# For DMA and UDMA, 0xf (1111) means 'disable'.\n"
"_CFG_# 0x0fac means 'use PIO mode 4, DMA mode 2, disable UltraDMA'.\n"
"_CFG_# (0xc=1100, 0xa=1010, 0xf=1111)\n"
"_CFG_# 0x0000 means \"use whatever the drive claims to support\".\n"
"_CFG_wd*\\011at wdc? channel ? drive ? flags 0x0000\n"
"_CFG_#wd*\\011at pciide? channel ? drive ? flags 0x0000\n"
"_CFG_\n"
"_CFG_# ATAPI bus support\n"
"_CFG_#atapibus* at wdc? channel ?\n"
"_CFG_\n"
"_CFG_# ATAPI devices\n"
"_CFG_# flags have the same meaning as for IDE drives.\n"
"_CFG_#cd*\\011at atapibus? drive ? flags 0x0000\\011# ATAPI CD-ROM drives\n"
"_CFG_#sd*\\011at atapibus? drive ? flags 0x0000\\011# ATAPI disk drives\n"
"_CFG_#st*\\011at atapibus? drive ? flags 0x0000\\011# ATAPI tape drives\n"
"_CFG_#uk*\\011at atapibus? drive ? flags 0x0000\\011# ATAPI unknown\n"
"_CFG_\n"
"_CFG_# Network Interfaces\n"
"_CFG_\n"
"_CFG_# PCMCIA network interfaces\n"
"_CFG_ne*\\011at pcmcia? function ?\\011\\011# NE2000-compatible Ethernet\n"
"_CFG_\n"
"_CFG_# CBus network interfaces\n"
"_CFG_#ne0\\011at cbus? port 0x56d0 irq 6\\011# NE[12]000 ethernet cards\n"
"_CFG_\n"
"_CFG_# Pull in optional local configuration\n"
"_CFG_include\\011\"arch/pc98/conf/GENERIC.local\"\n"
"_CFG_\n"
"_CFG_# Pseudo-Devices\n"
"_CFG_\n"
"_CFG_# disk/mass storage pseudo-devices\n"
"_CFG_pseudo-device\\011md\\011\\0111\\011# memory disk device (ramdisk)\n"
"_CFG_pseudo-device\\011vnd\\011\\0114\\011# disk-like interface to files\n"
"_CFG_\n"
"_CFG_# network pseudo-devices\n"
"_CFG_#pseudo-device\\011bpfilter\\0118\\011# Berkeley packet filter\n"
"_CFG_#pseudo-device\\011ipfilter\\011\\011# IP filter (firewall) and NAT\n"
"_CFG_pseudo-device\\011loop\\011\\011\\011# network loopback\n"
"_CFG_#pseudo-device\\011ppp\\011\\0112\\011# Point-to-Point Protocol\n"
"_CFG_#pseudo-device\\011gre\\011\\0112\\011# generic L3 over IP tunnel\n"
"_CFG_#pseudo-device\\011ipip\\011\\0112\\011# IP Encapsulation within IP (RFC 2003)\n"
"_CFG_#pseudo-device\\011gif\\011\\0114\\011# IPv[46] over IPv[46] tunnel (RFC1933)\n"
"_CFG_#pseudo-device\\011faith\\011\\0111\\011# IPv[46] tcp relay translation i/f\n"
"_CFG_#pseudo-device\\011stf\\011\\0111\\011# 6to4 IPv6 over IPv4 encapsulation\n"
"_CFG_#pseudo-device\\011vlan\\011\\011\\011# IEEE 802.1q encapsulation\n"
"_CFG_\n"
"_CFG_# miscellaneous pseudo-devices\n"
"_CFG_pseudo-device\\011pty\\011\\011\\011# pseudo-terminals\n"
"_CFG_#pseudo-device\\011sequencer\\0111\\011# MIDI sequencer\n"
"_CFG_# rnd works; RND_COM does not on port i386 yet.\n"
"_CFG_pseudo-device\\011rnd\\011\\011\\011# /dev/random and in-kernel generator\n"
"_CFG_#options \\011RND_COM\\011\\011\\011# use \"com\" randomness as well (BROKEN)\n"
"_CFG_pseudo-device\\011clockctl\\011\\011# user control of clock subsystem\n"
#ifdef INCLUDE_CONFIG_FILE

"_CFG_### END CONFIG FILE \"YOTSUHA\"\n"
"_CFG_### (included from \"arch/pc98/conf/std.pc98\")\n"
"_CFG_###> # $NetBSD$\n"
"_CFG_###> #\n"
"_CFG_###> # standard, required NetBSD/pc98 'options'\n"
"_CFG_###> \n"
"_CFG_###> machine pc98 i386\n"
"_CFG_###> \n"
"_CFG_###> options \\011EXEC_AOUT\\011# exec a.out binaries\n"
"_CFG_###> options\\011\\011EXEC_ELF32\\011# exec ELF binaries\n"
"_CFG_###> options \\011EXEC_SCRIPT\\011# exec #! scripts\n"
"_CFG_###> \n"
"_CFG_###> options \\011INET6_MD_CKSUM\\011# machine-dependant code for in6_cksum\n"
"_CFG_###> #options \\011CRYPTO_MD_DES_ENC\\011# machine-dependant code for DES\n"
"_CFG_###> #options \\011CRYPTO_MD_DES_CBC\\011# machine-dependant DES CBC code\n"
"_CFG_###> #options \\011CRYPTO_MD_BF_ENC\\011# machine-dependant code for BF_encrypt\n"
"_CFG_###> #options \\011CRYPTO_MD_BF_CBC\\011# careful: uses bswapl, requires 486\n"
"_CFG_### (end include \"arch/pc98/conf/std.pc98\")\n"
"_CFG_### (included from \"arch/pc98/conf/GENERIC.local\")\n"
"_CFG_###> #\\011$NetBSD$\n"
"_CFG_###> #\n"
"_CFG_###> #\\011GENERIC.local -- local additions to the GENERIC configuration\n"
"_CFG_###> #\n"
"_CFG_### (end include \"arch/pc98/conf/GENERIC.local\")\n"
#endif /* INCLUDE_CONFIG_FILE */
;
#endif /* INCLUDE_CONFIG_FILE || INCLUDE_JUST_CONFIG */
#endif /* CONFIG_FILE */
