/*	$NetBSD$	*/
/*	$NecBSD: busiosubr.c,v 1.30.4.4 1999/08/28 02:25:35 honda Exp $	*/

/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 1996, 1997, 1998
 *	NetBSD/i386 porting staff. All rights reserved.
 * 
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * Copyright (c) 1997, 1998
 *	Naofumi HONDA.  All rights reserved.
 */

#include "opt_cputype.h"
#include "opt_ddb.h"
#include "opt_largepages.h"

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/signalvar.h>
#include <sys/kernel.h>
#include <sys/proc.h>
#include <sys/user.h>
#include <sys/exec.h>
#include <sys/buf.h>
#include <sys/reboot.h>
#include <sys/conf.h>
#include <sys/file.h>
#include <sys/callout.h>
#include <sys/malloc.h>
#include <sys/mbuf.h>
#include <sys/msgbuf.h>
#include <sys/mount.h>
#include <sys/vnode.h>
#include <sys/device.h>
#include <sys/extent.h>
#include <sys/syscallargs.h>

#include <uvm/uvm.h>
#include <uvm/uvm_page.h>

#include <sys/sysctl.h>

#define _PC98_BUS_DMA_PRIVATE
#include <machine/bus.h>

#include <machine/cpu.h>
#include <machine/cpufunc.h>
#include <machine/gdt.h>
#include <machine/pio.h>
#include <machine/psl.h>
#include <machine/reg.h>
#include <machine/specialreg.h>

#include <pc98/pc98/pc98_machdep.h>

static	long ioport_ex_storage[EXTENT_FIXED_STORAGE_SIZE(8) / sizeof(long)];
static	long iomem_ex_storage[EXTENT_FIXED_STORAGE_SIZE(8) / sizeof(long)];
struct	extent *ioport_ex;
struct	extent *iomem_ex;
static	int ioport_malloc_safe;

int     _bus_dmamap_load_buffer __P((bus_dma_tag_t, bus_dmamap_t, void *,
	    bus_size_t, struct proc *, int, paddr_t *, int *, int));

_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_DA_io,u_int8_t,1)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_DA_io,u_int16_t,2)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_DA_io,u_int32_t,4)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_DA_mem,u_int8_t,1)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_DA_mem,u_int16_t,2)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_DA_mem,u_int32_t,4)

_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_RA_io,u_int8_t,1)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_RA_io,u_int16_t,2)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_RA_io,u_int32_t,4)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_RA_mem,u_int8_t,1)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_RA_mem,u_int16_t,2)
_BUS_SPACE_CALL_FUNCS_PROTO(SBUS_RA_mem,u_int32_t,4)

struct bus_space_tag SBUS_io_space_tag = {
	0,
	BUS_SPACE_IO,
	NULL,

	i386_memio_map,
	i386_memio_unmap,
	i386_memio_free,
	i386_memio_subregion,
	i386_bus_space_map_load,
	i386_bus_space_map_unload,
	i386_bus_space_map_activate,
	i386_bus_space_map_deactivate,
	i386_bus_space_map_prefer,
	NULL,

	/* direct bus access methods */
	{
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_DA_io,u_int8_t,1),
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_DA_io,u_int16_t,2),
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_DA_io,u_int32_t,4),
	},

	/* relocate bus access methods */
	{
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_RA_io,u_int8_t,1),
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_RA_io,u_int16_t,2),
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_RA_io,u_int32_t,4),
	}
};

struct bus_space_tag SBUS_mem_space_tag = {
	0,
	BUS_SPACE_MEM,
	NULL,
	
	i386_memio_map,
	i386_memio_unmap,
	i386_memio_free,
	i386_memio_subregion,
	i386_bus_space_map_load,
	i386_bus_space_map_unload,
	i386_bus_space_map_activate,
	i386_bus_space_map_deactivate,
	i386_bus_space_map_prefer,
	NULL,

	/* direct bus access methods */
	{
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_DA_mem,u_int8_t,1),
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_DA_mem,u_int16_t,2),
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_DA_mem,u_int32_t,4),
	},

	/* relocate bus access methods */
	{
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_RA_mem,u_int8_t,1),
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_RA_mem,u_int16_t,2),
		_BUS_SPACE_CALL_FUNCS_TAB(SBUS_RA_mem,u_int32_t,4),
	}
};

#define	STATIC_IOH_NUM	32

int i386_bus_space_handle_alloc __P((bus_space_tag_t, bus_addr_t, bus_size_t, bus_space_handle_t *, bus_space_handle_t));
void i386_bus_space_handle_free __P((bus_space_tag_t, bus_space_handle_t, size_t));
int i386_mem_add_mapping __P((bus_space_tag_t, bus_addr_t, bus_size_t, int, bus_addr_t *));
void i386_mem_remove_mapping __P((bus_space_tag_t, bus_addr_t, bus_size_t));

#define	BMAP_LOAD	1
#define	BMAP_UNLOAD	0

void i386_iomap_subregion __P((bus_space_tag_t, bus_space_handle_t, int));
int i386_iomap_scan __P((bus_space_tag_t, bus_space_handle_t, int));
int i386_iomap_alloc __P((bus_space_tag_t, bus_space_handle_t));
void i386_iomap_free __P((bus_space_tag_t, bus_space_handle_t));
static int i386_iomap_check __P((bus_addr_t));
static void i386_iomap_set __P((bus_addr_t));
static void i386_iomap_clr __P((bus_addr_t));
static int i386_iomap_check_range __P((bus_addr_t, bus_size_t));

int i386_mem_activate __P((bus_space_tag_t, bus_space_handle_t));
int i386_mem_deactivate __P((bus_space_tag_t, bus_space_handle_t));

static struct bus_space_handle i386_bss_handle[STATIC_IOH_NUM];
static void bus_space_iat_init __P((bus_space_handle_t));

bus_addr_t i386_bus_space_iat_1[BUS_SPACE_IAT_MAXSIZE];
bus_addr_t i386_bus_space_iat_2[BUS_SPACE_IAT_MAXSIZE];

#define	IO_SPACE_MAXADDR 0x10000
#define IO_SPACE_MAXIDX	(0x10000 / (sizeof(u_int32_t) * NBBY))

bus_space_handle_t i386_bus_space_systm_handle;
struct bus_space_handle i386_bus_space_systm_handle_store;

u_int32_t i386_iomap_array[IO_SPACE_MAXIDX];
/* ICU */
static bus_addr_t i386_systm_port[] = { 0x00, 0x02, 0x08, 0x0a, 0xf0 };

/*************************************************************************
 * map init
 *************************************************************************/
static void
bus_space_iat_init(bsh)
	bus_space_handle_t bsh;
{
	int i;

	for (i = 0; i < bsh->bsh_maxiatsz; i++)
		bsh->bsh_iat[i] = bsh->bsh_base + i;
}

static void
pc98_bus_space_init(void)
{
	bus_space_tag_t t = PC98_BUS_SPACE_IO;
	bus_space_handle_t ioh;
	int i;

	ioh = &i386_bus_space_systm_handle_store;

	i386_bus_space_systm_handle = ioh;
	ioh->bsh_sz = IO_SPACE_MAXADDR;
	ioh->bsh_flags = BUSIOH_SYSTM | BUSIOH_INUSE | BUSIOH_STATIC;
	ioh->bsh_bam = t->bs_da;
	bus_space_iat_init(ioh);
	
	for (i = 0; i < BUS_SPACE_IAT_MAXSIZE; i++) {
		i386_bus_space_iat_1[i] = i;
		i386_bus_space_iat_2[i] = 2 * i;
	}

	/* XXX:
	 * register io ports which are allocated out of bus space map.
	 */
	for (i = 0; i < sizeof(i386_systm_port)/sizeof(i386_systm_port[0]); i++)
		i386_iomap_set(i386_systm_port[i]);
}

void
i386_bus_space_init()
{

	/*
	 * Initialize the I/O port and I/O mem extent maps.
	 * Note: we don't have to check the return value since
	 * creation of a fixed extent map will never fail (since
	 * descriptor storage has already been allocated).
	 *
	 * N.B. The iomem extent manages _all_ physical addresses
	 * on the machine.  When the amount of RAM is found, the two
	 * extents of RAM are allocated from the map (0 -> io/mem hole
	 * and end of io/mem hole -> end of RAM).
	 */
	ioport_ex = extent_create("ioport", 0x0, 0xffff, M_DEVBUF,
	    (caddr_t)ioport_ex_storage, sizeof(ioport_ex_storage),
	    EX_NOCOALESCE|EX_NOWAIT);
	iomem_ex = extent_create("iomem", 0x0, 0xffffffff, M_DEVBUF,
	    (caddr_t)iomem_ex_storage, sizeof(iomem_ex_storage),
	    EX_NOCOALESCE|EX_NOWAIT);

	pc98_bus_space_init();
}

void
i386_bus_space_mallocok(void)
{

	ioport_malloc_safe = 1;
}


/*************************************************************************
 * load & unload
 *************************************************************************/
int
i386_bus_space_map_load(t, bsh, size, iat, flags)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
	bus_size_t size;
	bus_space_iat_t iat;
	u_int flags;
{
	int i;

	if ((caddr_t) iat < (caddr_t) KERNBASE)
		panic("i386_bus_space_map_load: illegal bus iat");

	if (size > bsh->bsh_maxiatsz) {
		printf("i386_bus_space_map_load: map size too large\n");
		goto bad;
	}	

	i386_bus_space_map_unload(t, bsh);
	for (i = 0; i < bsh->bsh_maxiatsz; i++) {
		if (i < size)
			bsh->bsh_iat[i] = iat[i];
		else
			bsh->bsh_iat[i] = 0;
		bsh->bsh_iat[i] += bsh->bsh_base;
	}				

	bsh->bsh_iatsz = size;
	switch (t->bs_tag) {
	default:
		break;

	case BUS_SPACE_IO:
		if (bsh->bsh_pbsh == NULL) {
			if (i386_iomap_alloc(t, bsh) != 0) {
				i386_bus_space_map_unload(t, bsh);
				goto bad;
			}
		}
		else
			i386_iomap_subregion(t, bsh, BMAP_LOAD);
		break;

	case BUS_SPACE_MEM:
		break;
	}

	bsh->bsh_bam = t->bs_ra;	/* relocate access */
	return 0;

bad:
	if (flags & BUS_SPACE_MAP_FAILFREE)
		bus_space_unmap(t, bsh, bsh->bsh_sz);
	return EINVAL;
}

void
i386_bus_space_map_unload(t, bsh)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
{

	switch (t->bs_tag) {
	default:
		break;

	case BUS_SPACE_IO:
		i386_iomap_free(t, bsh);
		break;

	case BUS_SPACE_MEM:
		break;
	}

	bsh->bsh_bam = t->bs_da;	/* default: direct access */
	bsh->bsh_iatsz = 0;
	bus_space_iat_init(bsh);
}	

/*************************************************************************
 * activate deactivate
 *************************************************************************/
int
i386_bus_space_map_deactivate(t, bsh, flags)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
	u_int flags;
{

	if (bsh == NULL || bsh->bsh_pbsh != NULL)
		return 0;

	switch (t->bs_tag) {
	default:
		break;

	case BUS_SPACE_IO:
		i386_iomap_free(t, bsh);
		break;

	case BUS_SPACE_MEM:
		i386_mem_deactivate(t, bsh);
		break;
	}

	bsh->bsh_flags |= BUSIOH_DEACTIVATE;
	return 0;
}

int
i386_bus_space_map_activate(t, bsh, flags)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
	u_int flags;
{
	int error;

	if (bsh == NULL || bsh->bsh_pbsh != NULL)
		return 0;

	switch (t->bs_tag) {
	default:
		error = EINVAL;
		break;

	case BUS_SPACE_IO:
		error = i386_iomap_alloc(t, bsh);
		break;

	case BUS_SPACE_MEM:
		error = i386_mem_activate(t, bsh);
		break;
	}

	if (error)
		return EINVAL;

	bsh->bsh_flags &= ~BUSIOH_DEACTIVATE;
	return 0;
}

/*************************************************************************
 * handle allocation
 *************************************************************************/
int
i386_bus_space_handle_alloc(t, bpa, size, bshp, pbsh)
	bus_space_tag_t t;
	bus_addr_t bpa;
	bus_size_t size;
	bus_space_handle_t *bshp;
	bus_space_handle_t pbsh;
{
	bus_space_handle_t bsh = NULL;
	int i;

	if (ioport_malloc_safe) {
		bsh = (bus_space_handle_t)
		      malloc(sizeof(*bsh), M_DEVBUF, M_NOWAIT);
		if (bsh == NULL)
			return ENOMEM;
		bsh->bsh_flags = BUSIOH_INUSE;
	} else {
		for (i = 0; i < STATIC_IOH_NUM; i++) {
			bsh = &i386_bss_handle[i];
			if ((bsh->bsh_flags & BUSIOH_INUSE) == 0) {
				bsh->bsh_flags = BUSIOH_INUSE | BUSIOH_STATIC;
				break;
			}
		}

		if (i == STATIC_IOH_NUM) {
			printf("i386_bus_space_load: short of static handle\n");
			return ENOMEM;
		}
	}

	bsh->bsh_maxiatsz = BUS_SPACE_IAT_MAXSIZE;
	bsh->bsh_iatsz = 0;
	bsh->bsh_pbase = bsh->bsh_base = bpa;
	bsh->bsh_sz = size;
	bsh->bsh_pbsh = pbsh;
	bus_space_iat_init(bsh);
	if (t->bs_tag == BUS_SPACE_MEM)
		pmap_extract(pmap_kernel(), bpa, &bsh->bsh_pbase);

	bsh->bsh_bam = t->bs_da;		/* default: direct access */

	*bshp = bsh;
	return 0;
}

void
i386_bus_space_handle_free(t, bsh, size)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
	size_t size;
{

	if (bsh->bsh_flags & BUSIOH_SYSTM)
		panic("i386_bus_space_handle_free:  free systm handle"); 

	if ((bsh->bsh_flags & BUSIOH_INUSE) == 0)
		panic("i386_bus_space_handle_free: freed bus io handle");

	if (bsh->bsh_flags & BUSIOH_STATIC)
		bsh->bsh_flags = 0;
	else
		free(bsh, M_DEVBUF);
}

/*************************************************************************
 * map
 *************************************************************************/
int
i386_memio_map(t, bpa, size, flags, bshp)
	bus_space_tag_t t;
	bus_addr_t bpa;
	bus_size_t size;
	int flags;
	bus_space_handle_t *bshp;
{
	int error = 0;
	bus_addr_t tva;
	struct extent *ex;

	switch (t->bs_tag) {
	default:
		panic("i386_memio_map: bad bus space tag");
		break;
			
	case BUS_SPACE_IO:
		if (flags & BUS_SPACE_MAP_LINEAR)
			return (EOPNOTSUPP);

		error = i386_bus_space_handle_alloc(t, bpa, size, bshp, NULL);
		if (error != 0)
			return error;
		if (i386_iomap_alloc(t, *bshp) != 0) {
			i386_bus_space_handle_free(t, *bshp, size);
			error = EINVAL;
		}
		break;

	case BUS_SPACE_MEM:
		ex = iomem_ex;
		if (size == 0)
			size = PAGE_SIZE;

		error = extent_alloc_region(ex, bpa, size,
			EX_NOWAIT | (ioport_malloc_safe ? EX_MALLOCOK : 0));
		if (error != 0)
			return (error);

		error = i386_mem_add_mapping(t, bpa, size,
			(flags & BUS_SPACE_MAP_CACHEABLE) != 0, &tva);
		if (error != 0)
			goto membad;

		error = i386_bus_space_handle_alloc(t, tva, size, bshp, NULL);
		if (error != 0) {
			i386_mem_remove_mapping(t, tva, size);
			goto membad;
		}
		break;
	}

	return error;

membad:
	if (extent_free(ex, bpa, size, EX_NOWAIT |
	    		(ioport_malloc_safe ? EX_MALLOCOK : 0))) {
		printf("i386_memio_map: pa 0x%lx, size 0x%lx\n",
			bpa, size);
		printf("i386_memio_map: can't free region\n");
	}
	return error;
}

int
_i386_memio_map(t, bpa, size, flags, bshp)
	bus_space_tag_t t;
	bus_addr_t bpa;
	bus_size_t size;
	int flags;
	bus_space_handle_t *bshp;
{
	int error = 0;
	bus_addr_t tva;

	switch (t->bs_tag) {
	default:
		panic("_i386_memio_map: bad bus space tag");
		break;

	case BUS_SPACE_IO:
		if (flags & BUS_SPACE_MAP_LINEAR)
			return (EOPNOTSUPP);
		error = i386_bus_space_handle_alloc(t, bpa, size, bshp, NULL);
		break;

	case BUS_SPACE_MEM:
		if (size == 0)
			size = PAGE_SIZE;
		error = i386_mem_add_mapping(t, bpa, size,
			(flags & BUS_SPACE_MAP_CACHEABLE) != 0, &tva);
		if (error != 0)
			break;

		error = i386_bus_space_handle_alloc(t, bpa, size, bshp, NULL);
		if (error != 0)
			i386_mem_remove_mapping(t, tva, size);
		break;
	}

	return error;			
}

int
i386_memio_alloc(t, rstart, rend, size, alignment, boundary, flags,
    bpap, bshp)
	bus_space_tag_t t;
	bus_addr_t rstart, rend;
	bus_size_t size, alignment, boundary;
	int flags;
	bus_addr_t *bpap;
	bus_space_handle_t *bshp;
{
	struct extent *ex;
	bus_addr_t tva;
	u_long bpa;
	int error;

	switch (t->bs_tag) {
	default:
		panic("i386_memio_alloc: bad bus space tag");
		break;

	case BUS_SPACE_IO:
		if (flags & BUS_SPACE_MAP_LINEAR)
			return (EOPNOTSUPP);

		bpa = rstart;
		error = i386_bus_space_map_prefer(t, &bpa, rend - size,
						  alignment, size);
		if (error != 0)
			return error;

		error = i386_bus_space_handle_alloc(t, bpa, size, bshp, NULL);
		if (error != 0)
			return error;

		if (i386_iomap_alloc(t, *bshp) != 0) {
			i386_bus_space_handle_free(t, *bshp, size);
			return EINVAL;
		}
		break;

	case BUS_SPACE_MEM:
		if (size == 0)
			size = PAGE_SIZE;

		ex = iomem_ex;
		if (rstart < ex->ex_start || rend > ex->ex_end)
			panic("i386_memio_alloc: bad region start/end");

		error = extent_alloc_subregion(ex, rstart,
			rend, size, alignment, boundary, 
			EX_FAST | EX_NOWAIT |
			(ioport_malloc_safe ?  EX_MALLOCOK : 0), &bpa);
		if (error != 0)
			return (error);

		error = i386_mem_add_mapping(t, bpa, size, 
	    		(flags & BUS_SPACE_MAP_CACHEABLE) != 0, &tva);
		if (error != 0)
			goto membad;

		error = i386_bus_space_handle_alloc(t, tva, size, bshp, NULL);
		if (error != 0) {
			i386_mem_remove_mapping(t, tva, size);
			goto membad;
		}
		break;
	}

	*bpap = bpa;
	return 0;

membad:
	if (extent_free(iomem_ex, bpa, size, EX_NOWAIT |
			(ioport_malloc_safe ? EX_MALLOCOK : 0)))
	{
		printf("i386_memio_alloc: pa 0x%lx, size 0x%lx\n", bpa, size);
		printf("i386_memio_alloc: can't free region\n");
	}
	return error;
}

void
i386_memio_unmap(t, bsh, size)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
	bus_size_t size;
{

	if ((bsh->bsh_flags & BUSIOH_DEACTIVATE) == 0)
		i386_bus_space_map_deactivate(t, bsh, 0);

	switch (t->bs_tag) {
	default:
		panic("i386_memio_unmap: bad bus space tag");
		break;

	case BUS_SPACE_IO:
		break;

	case BUS_SPACE_MEM:
		if (bsh->bsh_pbsh == NULL)
			i386_mem_remove_mapping(t, bsh->bsh_base, bsh->bsh_sz);
		break;
	}

	i386_bus_space_handle_free(t, bsh, bsh->bsh_sz);
}

void    
i386_memio_free(t, bsh, size)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
	bus_size_t size;
{

	/* i386_memio_unmap() does all that we need to do. */
	i386_memio_unmap(t, bsh, bsh->bsh_sz);
}

int
i386_memio_subregion(t, pbsh, offset, size, tbshp)
	bus_space_tag_t t;
	bus_space_handle_t pbsh;
	bus_size_t offset, size;
	bus_space_handle_t *tbshp;
{
	int i, error = 0;
	bus_space_handle_t bsh;
	bus_addr_t pbase;

	pbase = pbsh->bsh_base + offset;
	switch (t->bs_tag) {
	case BUS_SPACE_IO:
		if (pbsh->bsh_iatsz > 0) {
			if (offset >= pbsh->bsh_iatsz || 
			    offset + size > pbsh->bsh_iatsz)
				return EINVAL;	
			pbase = pbsh->bsh_base;
		}
		break;

	case BUS_SPACE_MEM:
		if (pbsh->bsh_iatsz > 0)
			return EINVAL;
		if (offset > pbsh->bsh_sz || offset + size > pbsh->bsh_sz)
			return EINVAL;
		break;

	default:
		panic("i386_memio_subregion: bad bus space tag");
		break;
	}

	error = i386_bus_space_handle_alloc(t, pbase, size, &bsh, pbsh);
	if (error != 0)
		return error;

	switch (t->bs_tag) {
	case BUS_SPACE_IO:
		if (pbsh->bsh_iatsz > 0) {
			for (i = 0; i < size; i ++)
				bsh->bsh_iat[i] = pbsh->bsh_iat[i + offset];
			bsh->bsh_iatsz = size;
		}
		else if (pbsh->bsh_base > bsh->bsh_base ||
		  pbsh->bsh_base + pbsh->bsh_sz < bsh->bsh_base + bsh->bsh_sz) {
			i386_bus_space_handle_free(t, bsh, size);
			return EINVAL;
		}
		i386_iomap_subregion(t, bsh, BMAP_LOAD);
		break;

	case BUS_SPACE_MEM:
		break;
	}

	if (pbsh->bsh_iatsz > 0)
		bsh->bsh_bam = t->bs_ra;	/* relocate access */
	*tbshp = bsh;
	return error;
}

/*************************************************************************
 * prefer range check
 *************************************************************************/
int i386_io_map_prefer 
	__P((bus_space_tag_t, bus_addr_t *, bus_addr_t, bus_size_t, bus_size_t));
int i386_mem_map_prefer 
	__P((bus_space_tag_t, bus_addr_t *, bus_addr_t, bus_size_t, bus_size_t));

static bus_addr_t io_boundary[] = {0x1000, 0x300, 0x100};
#define	NEC_UIOSP_MASK			0xff
#define	NEC_UIOSP_SIZE			0x20
#define	NEC_UIOSP_START			0xd0
#define	NEC_UIOSP_END			0xf0

int
i386_io_map_prefer(t, start, end, align, size)
	bus_space_tag_t t;
	bus_addr_t *start;
	bus_addr_t end;
	bus_size_t align, size;
{
	bus_addr_t saddr;
	int try;

	if (size == 0)
		return EINVAL;

	if (align == 0)
		align = 0x8;

	/* I: select NEC user io space */
	if (size <= NEC_UIOSP_SIZE) {
		for (saddr = *start; saddr <= end; saddr += align) {
			u_long ta;

			ta = saddr & NEC_UIOSP_MASK;
			if (ta < NEC_UIOSP_START || ta >= NEC_UIOSP_END)
				continue;

			ta = (saddr + size - 1) & NEC_UIOSP_MASK;
			if (ta < NEC_UIOSP_START || ta >= NEC_UIOSP_END)
				continue;

			if (i386_iomap_check_range(saddr, size) == 0) {
				*start = saddr;
				return 0;
			}
		}
	}

		    
	/* II: find io space */
	for (try = 0; try < sizeof(io_boundary) / sizeof(bus_addr_t); try ++) {
		for (saddr = *start; saddr <= end; saddr += align) {
			if (saddr < io_boundary[try])
				continue;
			if (try != 0 && saddr >= io_boundary[try - 1])
				break;
			if (i386_iomap_check_range(saddr, size) == 0) {
				*start = saddr;
				return 0;
			}
		}
	}

	return ENOSPC;
}

int
i386_mem_map_prefer(t, start, end, align, size)
	bus_space_tag_t t;
	bus_addr_t *start;
	bus_addr_t end;
	bus_size_t align, size;
{
	bus_addr_t saddr, caddr;
	int error;

	if (size == 0)
		return EINVAL;
	size = i386_round_page(size);

	if (align < NBPG)
		align = NBPG;
	else
		align = i386_round_page(align);

	saddr = i386_trunc_page(*start);
	if (saddr < CBUSHOLE_USPACE_START)
		saddr = CBUSHOLE_USPACE_START;

	for ( ; saddr <= end; saddr += align) {
		for (caddr = saddr; caddr < saddr + size; caddr += NBPG) {
#if 0
			if (is_fake_page(i386_btop(caddr)) != 0)
				break;
#endif

			if (caddr >= CBUSHOLE_USPACE_END &&
			    caddr < CBUSHOLE_BIOS_END) /* bios */
				break;
		}

		if (caddr != saddr + size)
			continue;

		error = extent_alloc_region(iomem_ex, saddr, size,
			EX_FAST | EX_NOWAIT |
			(ioport_malloc_safe ? EX_MALLOCOK : 0));
		if (error == 0) {
			extent_free(iomem_ex, saddr, size, EX_NOWAIT |
	    			    (ioport_malloc_safe ? EX_MALLOCOK : 0));
			*start = saddr;
			return 0;
		}
	}
	return ENOSPC;
}
		
int
i386_bus_space_map_prefer(t, start, end, align, size)
	bus_space_tag_t t;
	bus_addr_t *start;
	bus_addr_t end;
	bus_size_t align, size;
{

	switch (t->bs_tag)
	{
	case BUS_SPACE_IO:
		return i386_io_map_prefer(t, start, end, align, size);
	case BUS_SPACE_MEM:
		return i386_mem_map_prefer(t, start, end, align, size);
	}

	return EINVAL;
}

/*************************************************************************
 * io map control
 *************************************************************************/
static int
i386_iomap_check_range(sport, size)
	bus_addr_t sport;
	bus_size_t size;
{
#define	TYPEBIT(type)	(NBBY * sizeof(type))
	bus_addr_t soffs, eoffs, port, eport;
	u_int32_t mask;
	u_int idx;

	/* check validity */
 	eport = sport + size;
	if (sport >= IO_SPACE_MAXADDR || eport >= IO_SPACE_MAXADDR ||
	    sport >= eport)
		return EINVAL;

	/* calculate start mask */
	soffs = sport % TYPEBIT(mask);
	mask = ~((1 << soffs) - 1);
	sport = sport - soffs;

	/* start */
	for (port = sport; port < eport; port += TYPEBIT(mask))
	{
		if (port + TYPEBIT(mask) > eport)
		{
			eoffs = eport % TYPEBIT(mask); 
			mask &= ((1 << eoffs) - 1);
		}

		idx = port / TYPEBIT(mask);
		if ((i386_iomap_array[idx] & mask) != 0)
			return EBUSY;

		mask = ~0;	
	}
	return 0;
}

static int
i386_iomap_check(port)
	bus_addr_t port;
{
	int idx = port / TYPEBIT(u_int32_t);
	u_int32_t mask = 1 << (port % TYPEBIT(u_int32_t));

	return i386_iomap_array[idx] & mask;
}

static void
i386_iomap_set(port)
	bus_addr_t port;
{
	int idx = port / TYPEBIT(u_int32_t);
	u_int32_t mask = 1 << (port % TYPEBIT(u_int32_t));

	i386_iomap_array[idx] |= mask;
}

static void
i386_iomap_clr(port)
	bus_addr_t port;
{
	int idx = port / TYPEBIT(u_int32_t);
	u_int32_t mask = 1 << (port % TYPEBIT(u_int32_t));

	i386_iomap_array[idx] &= ~mask;
}

void
i386_iomap_subregion(t, bsh, set)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
	int set;
{
	register int i;
	
	if (bsh->bsh_iatsz == 0)
	{
		bus_addr_t port = bsh->bsh_base;

		for (i = 0; i < bsh->bsh_sz; i ++)
		{
			if (port + i >= IO_SPACE_MAXADDR)
				break;
			if (set == BMAP_LOAD)
				i386_iomap_set(port + i);
			else
				i386_iomap_clr(port + i);
		}
	}
	else
	{
		for (i = 0; i < bsh->bsh_iatsz; i ++)
		{
			if (bsh->bsh_iat[i] >= IO_SPACE_MAXADDR)
				continue;
			if (set == BMAP_LOAD)
				i386_iomap_set(bsh->bsh_iat[i]);
			else
				i386_iomap_clr(bsh->bsh_iat[i]);
		}
	}
}

int
i386_iomap_scan(t, bsh, set)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
	int set;
{
	int size, bit, i;
	u_char *s;

	s = (set == BMAP_LOAD) ? "busy" : "freed";		
	if (bsh->bsh_iatsz == 0)
	{
		bus_addr_t port = bsh->bsh_base;

		size = bsh->bsh_sz;
		for (i = 0; i < size; i ++)
		{
			if (port + i >= IO_SPACE_MAXADDR)
				return -1;

			bit = i386_iomap_check(port + i);
			if ((set == BMAP_LOAD && bit != 0) ||
			    (set == BMAP_UNLOAD && bit == 0))
			{
				printf("iomem_map: io port(D) 0x%lx %s\n",
					port + i, s);
				return -1;
			}
		}
	}
	else
	{
		size = bsh->bsh_iatsz;
		for (i = 0; i < size; i ++)
		{
			if (bsh->bsh_iat[i] >= IO_SPACE_MAXADDR)
				return -1;

			bit = i386_iomap_check(bsh->bsh_iat[i]);
			if ((set == BMAP_LOAD && bit != 0) ||
			    (set == BMAP_UNLOAD && bit == 0))
			{
				printf("iomem_map: io port(R) 0x%lx %s\n",
					bsh->bsh_iat[i], s);
				return -1;
			}
		}
	}
	return size;
}

int
i386_iomap_alloc(t, bsh)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
{
	int size;

	size = i386_iomap_scan(t, bsh, BMAP_LOAD);
	if (size < 0)
		return EBUSY;
	if (size > 0)
	{
		i386_iomap_subregion(t, bsh, BMAP_LOAD);
		bsh->bsh_flags |= BUSIOH_BITMAP;
	}
	return 0;
}

void
i386_iomap_free(t, bsh)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
{

	if ((bsh->bsh_flags & BUSIOH_BITMAP) == 0)
		return;

	(void) i386_iomap_scan(t, bsh, BMAP_UNLOAD);
	i386_iomap_subregion(t, bsh, BMAP_UNLOAD);
	bsh->bsh_flags &= ~BUSIOH_BITMAP;
}

/*************************************************************************
 * mem map control
 *************************************************************************/
int
i386_mem_deactivate(t, bsh)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
{

	if (extent_free(iomem_ex, bsh->bsh_pbase, bsh->bsh_sz, EX_NOWAIT |
	    		(ioport_malloc_safe ? EX_MALLOCOK : 0)))
		return EINVAL;
	return 0;
}
	
int
i386_mem_activate(t, bsh)
	bus_space_tag_t t;
	bus_space_handle_t bsh;
{
	u_long bpa, va, eva, pa, endpa;
	pt_entry_t *pte;
	int error;

	bpa = bsh->bsh_pbase;
	pa = i386_trunc_page(bpa);
	endpa = i386_round_page(bpa + bsh->bsh_sz);
	va = i386_trunc_page(bsh->bsh_base);
	eva = i386_round_page(bsh->bsh_base + bsh->bsh_sz);

	error = extent_alloc_region(iomem_ex, bpa, bsh->bsh_sz,
		EX_NOWAIT | (ioport_malloc_safe ? EX_MALLOCOK : 0));
	if (error != 0)
		return error;

	pmap_remove(pmap_kernel(), va, eva);
	for (; pa < endpa; pa += NBPG, va += NBPG) {
		pmap_enter(pmap_kernel(), va, pa,
		    VM_PROT_READ | VM_PROT_WRITE, 0);
		if (cpu_class != CPUCLASS_386) {
			pte = kvtopte(va);
			*pte |= PG_N; /* XXX */
#ifdef LARGEPAGES
			if (*pte & PG_PS)
				pmap_update_pg(va & PG_LGFRAME);
			else
#endif /* LARGEPAGES */
				pmap_update_pg(va);
		}
	}
	return 0;
}

void
i386_mem_remove_mapping(t, sva, size)
	bus_space_tag_t t;
	bus_addr_t sva;
	bus_size_t size;
{
	bus_addr_t va, endva;

	va = i386_trunc_page(sva);
	endva = i386_round_page(sva + size);

#ifdef DIAGNOSTIC
	if (endva <= va)
		panic("i386_memio_unmap: overflow");
#endif

	/*
	 * Free the kernel virtual mapping.
	 */
	uvm_km_free(kernel_map, va, endva - va);
}

int
i386_mem_add_mapping(t, bpa, size, cacheable, tva)
	bus_space_tag_t t;
	bus_addr_t bpa;
	bus_size_t size;
	int cacheable;
	bus_addr_t *tva;
{
	u_long pa, endpa;
	vaddr_t va;
	pt_entry_t *pte;
	int32_t cpumask = 0;

	pa = i386_trunc_page(bpa);
	endpa = i386_round_page(bpa + size);

#ifdef DIAGNOSTIC
	if (endpa <= pa)
		panic("i386_mem_add_mapping: overflow");
#endif

	va = uvm_km_valloc(kernel_map, endpa - pa);
	if (va == 0)
		return ENOMEM;

	*tva = va + (bpa & PGOFSET);

	for (; pa < endpa; pa += PAGE_SIZE, va += PAGE_SIZE) {
		pmap_kenter_pa(va, pa, VM_PROT_READ | VM_PROT_WRITE);

		/*
		 * PG_N doesn't exist on 386's, so we assume that
		 * the mainboard has wired up device space non-cacheable
		 * on those machines.
		 *
		 * Note that it's not necessary to use atomic ops to
		 * fiddle with the PTE here, because we don't care
		 * about mod/ref information.
		 *
		 * XXX should hand this bit to pmap_kenter_pa to
		 * save the extra invalidate!
		 *
		 * XXX extreme paranoia suggests tlb shootdown belongs here.
		 */
		if (cpu_class != CPUCLASS_386) {
			pte = kvtopte(va);
			if (cacheable)
				*pte &= ~PG_N;
			else
				*pte |= PG_N;
			pmap_tlb_shootdown(pmap_kernel(), va, *pte, &cpumask);
		}
	}

	pmap_tlb_shootnow(cpumask);
	pmap_update(pmap_kernel());

	return 0;
}

/*
 * Common function for DMA map creation.  May be called by bus-specific
 * DMA map creation functions.
 */
int
_bus_dmamap_create(t, size, nsegments, maxsegsz, boundary, flags, dmamp)
	bus_dma_tag_t t;
	bus_size_t size;
	int nsegments;
	bus_size_t maxsegsz;
	bus_size_t boundary;
	int flags;
	bus_dmamap_t *dmamp;
{
	struct i386_bus_dmamap *map;
	void *mapstore;
	size_t mapsize;

	/*
	 * Allocate and initialize the DMA map.  The end of the map
	 * is a variable-sized array of segments, so we allocate enough
	 * room for them in one shot.
	 *
	 * Note we don't preserve the WAITOK or NOWAIT flags.  Preservation
	 * of ALLOCNOW notifies others that we've reserved these resources,
	 * and they are not to be freed.
	 *
	 * The bus_dmamap_t includes one bus_dma_segment_t, hence
	 * the (nsegments - 1).
	 */
	mapsize = sizeof(struct i386_bus_dmamap) +
	    (sizeof(bus_dma_segment_t) * (nsegments - 1));
	if ((mapstore = malloc(mapsize, M_DMAMAP,
	    (flags & BUS_DMA_NOWAIT) ? M_NOWAIT : M_WAITOK)) == NULL)
		return (ENOMEM);

	memset(mapstore, 0, mapsize);
	map = (struct i386_bus_dmamap *)mapstore;
	map->_dm_size = size;
	map->_dm_segcnt = nsegments;
	map->_dm_maxsegsz = maxsegsz;
	map->_dm_boundary = boundary;
	map->_dm_bounce_thresh = t->_bounce_thresh;
	map->_dm_flags = flags & ~(BUS_DMA_WAITOK|BUS_DMA_NOWAIT);
	map->dm_mapsize = 0;		/* no valid mappings */
	map->dm_nsegs = 0;

	*dmamp = map;
	return (0);
}

/*
 * Common function for DMA map destruction.  May be called by bus-specific
 * DMA map destruction functions.
 */
void
_bus_dmamap_destroy(t, map)
	bus_dma_tag_t t;
	bus_dmamap_t map;
{

	free(map, M_DMAMAP);
}

/*
 * Common function for loading a DMA map with a linear buffer.  May
 * be called by bus-specific DMA map load functions.
 */
int
_bus_dmamap_load(t, map, buf, buflen, p, flags)
	bus_dma_tag_t t;
	bus_dmamap_t map;
	void *buf;
	bus_size_t buflen;
	struct proc *p;
	int flags;
{
	paddr_t lastaddr;
	int seg, error;

	/*
	 * Make sure that on error condition we return "no valid mappings".
	 */
	map->dm_mapsize = 0;
	map->dm_nsegs = 0;

	if (buflen > map->_dm_size)
		return (EINVAL);

	seg = 0;
	error = _bus_dmamap_load_buffer(t, map, buf, buflen, p, flags,
	    &lastaddr, &seg, 1);
	if (error == 0) {
		map->dm_mapsize = buflen;
		map->dm_nsegs = seg + 1;
	}
	return (error);
}

/*
 * Like _bus_dmamap_load(), but for mbufs.
 */
int
_bus_dmamap_load_mbuf(t, map, m0, flags)
	bus_dma_tag_t t;
	bus_dmamap_t map;
	struct mbuf *m0;
	int flags;
{
	paddr_t lastaddr;
	int seg, error, first;
	struct mbuf *m;

	/*
	 * Make sure that on error condition we return "no valid mappings."
	 */
	map->dm_mapsize = 0;
	map->dm_nsegs = 0;

#ifdef DIAGNOSTIC
	if ((m0->m_flags & M_PKTHDR) == 0)
		panic("_bus_dmamap_load_mbuf: no packet header");
#endif

	if (m0->m_pkthdr.len > map->_dm_size)
		return (EINVAL);

	first = 1;
	seg = 0;
	error = 0;
	for (m = m0; m != NULL && error == 0; m = m->m_next) {
		error = _bus_dmamap_load_buffer(t, map, m->m_data, m->m_len,
		    NULL, flags, &lastaddr, &seg, first);
		first = 0;
	}
	if (error == 0) {
		map->dm_mapsize = m0->m_pkthdr.len;
		map->dm_nsegs = seg + 1;
	}
	return (error);
}

/*
 * Like _bus_dmamap_load(), but for uios.
 */
int
_bus_dmamap_load_uio(t, map, uio, flags)
	bus_dma_tag_t t;
	bus_dmamap_t map;
	struct uio *uio;
	int flags;
{
	paddr_t lastaddr;
	int seg, i, error, first;
	bus_size_t minlen, resid;
	struct proc *p = NULL;
	struct iovec *iov;
	caddr_t addr;

	/*
	 * Make sure that on error condition we return "no valid mappings."
	 */
	map->dm_mapsize = 0;
	map->dm_nsegs = 0;

	resid = uio->uio_resid;
	iov = uio->uio_iov;

	if (uio->uio_segflg == UIO_USERSPACE) {
		p = uio->uio_procp;
#ifdef DIAGNOSTIC
		if (p == NULL)
			panic("_bus_dmamap_load_uio: USERSPACE but no proc");
#endif
	}

	first = 1;
	seg = 0;
	error = 0;
	for (i = 0; i < uio->uio_iovcnt && resid != 0 && error == 0; i++) {
		/*
		 * Now at the first iovec to load.  Load each iovec
		 * until we have exhausted the residual count.
		 */
		minlen = resid < iov[i].iov_len ? resid : iov[i].iov_len;
		addr = (caddr_t)iov[i].iov_base;

		error = _bus_dmamap_load_buffer(t, map, addr, minlen,
		    p, flags, &lastaddr, &seg, first);
		first = 0;

		resid -= minlen;
	}
	if (error == 0) {
		map->dm_mapsize = uio->uio_resid;
		map->dm_nsegs = seg + 1;
	}
	return (error);
}

/*
 * Like _bus_dmamap_load(), but for raw memory allocated with
 * bus_dmamem_alloc().
 */
int
_bus_dmamap_load_raw(t, map, segs, nsegs, size, flags)
	bus_dma_tag_t t;
	bus_dmamap_t map;
	bus_dma_segment_t *segs;
	int nsegs;
	bus_size_t size;
	int flags;
{

	panic("_bus_dmamap_load_raw: not implemented");
}

/*
 * Common function for unloading a DMA map.  May be called by
 * bus-specific DMA map unload functions.
 */
void
_bus_dmamap_unload(t, map)
	bus_dma_tag_t t;
	bus_dmamap_t map;
{

	/*
	 * No resources to free; just mark the mappings as
	 * invalid.
	 */
	map->dm_mapsize = 0;
	map->dm_nsegs = 0;
}

/*
 * Common function for DMA map synchronization.  May be called
 * by bus-specific DMA map synchronization functions.
 */
void
_bus_dmamap_sync(t, map, offset, len, ops)
	bus_dma_tag_t t;
	bus_dmamap_t map;
	bus_addr_t offset;
	bus_size_t len;
	int ops;
{

	/* Nothing to do here. */
}

/*
 * Common function for DMA-safe memory allocation.  May be called
 * by bus-specific DMA memory allocation functions.
 */
int
_bus_dmamem_alloc(t, size, alignment, boundary, segs, nsegs, rsegs, flags)
	bus_dma_tag_t t;
	bus_size_t size, alignment, boundary;
	bus_dma_segment_t *segs;
	int nsegs;
	int *rsegs;
	int flags;
{
	extern paddr_t avail_end;

	return (_bus_dmamem_alloc_range(t, size, alignment, boundary,
	    segs, nsegs, rsegs, flags, 0, trunc_page(avail_end)));
}

/*
 * Common function for freeing DMA-safe memory.  May be called by
 * bus-specific DMA memory free functions.
 */
void
_bus_dmamem_free(t, segs, nsegs)
	bus_dma_tag_t t;
	bus_dma_segment_t *segs;
	int nsegs;
{
	struct vm_page *m;
	bus_addr_t addr;
	struct pglist mlist;
	int curseg;

	/*
	 * Build a list of pages to free back to the VM system.
	 */
	TAILQ_INIT(&mlist);
	for (curseg = 0; curseg < nsegs; curseg++) {
		for (addr = segs[curseg].ds_addr;
		    addr < (segs[curseg].ds_addr + segs[curseg].ds_len);
		    addr += PAGE_SIZE) {
			m = PHYS_TO_VM_PAGE(addr);
			TAILQ_INSERT_TAIL(&mlist, m, pageq);
		}
	}

	uvm_pglistfree(&mlist);
}

/*
 * Common function for mapping DMA-safe memory.  May be called by
 * bus-specific DMA memory map functions.
 */
int
_bus_dmamem_map(t, segs, nsegs, size, kvap, flags)
	bus_dma_tag_t t;
	bus_dma_segment_t *segs;
	int nsegs;
	size_t size;
	caddr_t *kvap;
	int flags;
{
	vaddr_t va;
	bus_addr_t addr;
	int curseg;

	size = round_page(size);

	va = uvm_km_valloc(kernel_map, size);

	if (va == 0)
		return (ENOMEM);

	*kvap = (caddr_t)va;

	for (curseg = 0; curseg < nsegs; curseg++) {
		for (addr = segs[curseg].ds_addr;
		    addr < (segs[curseg].ds_addr + segs[curseg].ds_len);
		    addr += PAGE_SIZE, va += PAGE_SIZE, size -= PAGE_SIZE) {
			if (size == 0)
				panic("_bus_dmamem_map: size botch");
			pmap_enter(pmap_kernel(), va, addr,
			    VM_PROT_READ | VM_PROT_WRITE,
			    PMAP_WIRED | VM_PROT_READ | VM_PROT_WRITE);
		}
	}
	pmap_update(pmap_kernel());

	return (0);
}

/*
 * Common function for unmapping DMA-safe memory.  May be called by
 * bus-specific DMA memory unmapping functions.
 */
void
_bus_dmamem_unmap(t, kva, size)
	bus_dma_tag_t t;
	caddr_t kva;
	size_t size;
{

#ifdef DIAGNOSTIC
	if ((u_long)kva & PGOFSET)
		panic("_bus_dmamem_unmap");
#endif

	size = round_page(size);

	uvm_km_free(kernel_map, (vaddr_t)kva, size);
}

/*
 * Common functin for mmap(2)'ing DMA-safe memory.  May be called by
 * bus-specific DMA mmap(2)'ing functions.
 */
paddr_t
_bus_dmamem_mmap(t, segs, nsegs, off, prot, flags)
	bus_dma_tag_t t;
	bus_dma_segment_t *segs;
	int nsegs;
	off_t off;
	int prot, flags;
{
	int i;

	for (i = 0; i < nsegs; i++) {
#ifdef DIAGNOSTIC
		if (off & PGOFSET)
			panic("_bus_dmamem_mmap: offset unaligned");
		if (segs[i].ds_addr & PGOFSET)
			panic("_bus_dmamem_mmap: segment unaligned");
		if (segs[i].ds_len & PGOFSET)
			panic("_bus_dmamem_mmap: segment size not multiple"
			    " of page size");
#endif
		if (off >= segs[i].ds_len) {
			off -= segs[i].ds_len;
			continue;
		}

		return (i386_btop((caddr_t)segs[i].ds_addr + off));
	}

	/* Page not found. */
	return (-1);
}

/**********************************************************************
 * DMA utility functions
 **********************************************************************/

/*
 * Utility function to load a linear buffer.  lastaddrp holds state
 * between invocations (for multiple-buffer loads).  segp contains
 * the starting segment on entrace, and the ending segment on exit.
 * first indicates if this is the first invocation of this function.
 */
int
_bus_dmamap_load_buffer(t, map, buf, buflen, p, flags, lastaddrp, segp, first)
	bus_dma_tag_t t;
	bus_dmamap_t map;
	void *buf;
	bus_size_t buflen;
	struct proc *p;
	int flags;
	paddr_t *lastaddrp;
	int *segp;
	int first;
{
	bus_size_t sgsize;
	bus_addr_t curaddr, lastaddr, baddr, bmask;
	vaddr_t vaddr = (vaddr_t)buf;
	int seg;
	pmap_t pmap;

	if (p != NULL)
		pmap = p->p_vmspace->vm_map.pmap;
	else
		pmap = pmap_kernel();

	lastaddr = *lastaddrp;
	bmask  = ~(map->_dm_boundary - 1);

	for (seg = *segp; buflen > 0 ; ) {
		/*
		 * Get the physical address for this segment.
		 */
		(void) pmap_extract(pmap, vaddr, &curaddr);

		/*
		 * If we're beyond the bounce threshold, notify
		 * the caller.
		 */
		if (map->_dm_bounce_thresh != 0 &&
		    curaddr >= map->_dm_bounce_thresh)
			return (EINVAL);

		/*
		 * Compute the segment size, and adjust counts.
		 */
		sgsize = PAGE_SIZE - ((u_long)vaddr & PGOFSET);
		if (buflen < sgsize)
			sgsize = buflen;

		/*
		 * Make sure we don't cross any boundaries.
		 */
		if (map->_dm_boundary > 0) {
			baddr = (curaddr + map->_dm_boundary) & bmask;
			if (sgsize > (baddr - curaddr))
				sgsize = (baddr - curaddr);
		}

		/*
		 * Insert chunk into a segment, coalescing with
		 * previous segment if possible.
		 */
		if (first) {
			map->dm_segs[seg].ds_addr = curaddr;
			map->dm_segs[seg].ds_len = sgsize;
			first = 0;
		} else {
			if (curaddr == lastaddr &&
			    (map->dm_segs[seg].ds_len + sgsize) <=
			     map->_dm_maxsegsz &&
			    (map->_dm_boundary == 0 ||
			     (map->dm_segs[seg].ds_addr & bmask) ==
			     (curaddr & bmask)))
				map->dm_segs[seg].ds_len += sgsize;
			else {
				if (++seg >= map->_dm_segcnt)
					break;
				map->dm_segs[seg].ds_addr = curaddr;
				map->dm_segs[seg].ds_len = sgsize;
			}
		}

		lastaddr = curaddr + sgsize;
		vaddr += sgsize;
		buflen -= sgsize;
	}

	*segp = seg;
	*lastaddrp = lastaddr;

	/*
	 * Did we fit?
	 */
	if (buflen != 0)
		return (EFBIG);		/* XXX better return value here? */
	return (0);
}

/*
 * Allocate physical memory from the given physical address range.
 * Called by DMA-safe memory allocation methods.
 */
int
_bus_dmamem_alloc_range(t, size, alignment, boundary, segs, nsegs, rsegs,
    flags, low, high)
	bus_dma_tag_t t;
	bus_size_t size, alignment, boundary;
	bus_dma_segment_t *segs;
	int nsegs;
	int *rsegs;
	int flags;
	paddr_t low;
	paddr_t high;
{
	paddr_t curaddr, lastaddr;
	struct vm_page *m;
	struct pglist mlist;
	int curseg, error;

	/* Always round the size. */
	size = round_page(size);

	/*
	 * Allocate pages from the VM system.
	 */
	error = uvm_pglistalloc(size, low, high, alignment, boundary,
	    &mlist, nsegs, (flags & BUS_DMA_NOWAIT) == 0);
	if (error)
		return (error);

	/*
	 * Compute the location, size, and number of segments actually
	 * returned by the VM code.
	 */
	m = mlist.tqh_first;
	curseg = 0;
	lastaddr = segs[curseg].ds_addr = VM_PAGE_TO_PHYS(m);
	segs[curseg].ds_len = PAGE_SIZE;
	m = m->pageq.tqe_next;

	for (; m != NULL; m = m->pageq.tqe_next) {
		curaddr = VM_PAGE_TO_PHYS(m);
#ifdef DIAGNOSTIC
		if (curaddr < low || curaddr >= high) {
			printf("vm_page_alloc_memory returned non-sensical"
			    " address 0x%lx\n", curaddr);
			panic("_bus_dmamem_alloc_range");
		}
#endif
		if (curaddr == (lastaddr + PAGE_SIZE))
			segs[curseg].ds_len += PAGE_SIZE;
		else {
			curseg++;
			segs[curseg].ds_addr = curaddr;
			segs[curseg].ds_len = PAGE_SIZE;
		}
		lastaddr = curaddr;
	}

	*rsegs = curseg + 1;

	return (0);
}
