#	$NetBSD$
#
#	Configuration variables (default values are below):
#
#	S	must be set to the top of the 'sys' tree.
#	PC98DST	may be set to the location of the directory where library
#		objects are to be built.  Defaults to ${.OBJDIR}/lib/i386.
#	PC98MISCCPPFLAGS
#		Miscellaneous cpp flags to be passed to the library's Makefile
#		when building.
#	PC98MISCMAKEFLAGS
#		Miscellaneous flags to be passed to the library's Makefile when
#		building.  See library's Makefile for more details about
#		supported flags and their default values.

# Default values:
PC98DST?=		${.OBJDIR}/lib/pc98

#PC98DIR=		$S/arch/pc98/stand/lib
I386LIB=		${I386DST}/libi386.a

PC98MAKE= \
	cd ${PC98DIR} && MAKEOBJDIRPREFIX= && unset MAKEOBJDIRPREFIX && \
	    MAKEOBJDIR=${PC98DST} ${MAKE} \
	    CC=${CC:Q} CFLAGS=${CFLAGS:Q} \
	    AS=${AS:Q} AFLAGS=${AFLAGS:Q} \
	    LD=${LD:Q} STRIP=${STRIP:Q} \
	    MACHINE=${MACHINE} MACHINE_ARCH=${MACHINE_ARCH:Q} \
	    PC98CPPFLAGS=${CPPFLAGS:S@^-I.@-I../../.@g:Q} \
	    PC98MISCCPPFLAGS=${PC98MISCCPPFLAGS:Q} \
	    ${PC98MISCMAKEFLAGS}

${I386LIB}:		.NOTMAIN __always_make_i386lib
	@echo making sure the i386 library is up to date...
	@${PC98MAKE} libi386.a

clean:			.NOTMAIN cleani386lib
cleani386lib:		.NOTMAIN
	@echo cleaning the i386 library objects
	@if [ -d "${PC98DST}" ]; then ${PC98MAKE} clean; fi

cleandir distclean:	.NOTMAIN cleandiri386lib
cleandiri386lib:	.NOTMAIN
	@echo cleandiring the i386 library objects
	@if [ -d "${PC98DST}" ]; then ${PC98MAKE} cleandir; fi

depend:			.NOTMAIN dependi386lib
dependi386lib:		.NOTMAIN __always_make_i386lib
	@echo depending the i386 library objects
	@${PC98MAKE} depend

__always_make_i386lib:	.NOTMAIN
	@mkdir -p ${PC98DST}
