/*	$NetBSD$	*/
/*	$NecBSD: start_bootsect.S,v 1.3.2.2.2.7.2.1 2000/07/26 01:49:52 kmatsuda Exp $	*/
/*	$NetBSD/i386: start_bootsect.S,v 1.12.2.2 2000/06/01 17:37:12 he Exp $	*/
	
/*
 * BIOS bootsector startup
 * parts from netbsd:sys/arch/i386/boot/start.S
 * and freebsd:sys/i386/boot/biosboot/boot2.S
 */
/*
 * parts from netbsd_pc98:sys/arch/i386/boot/start.S
 * and netbsd_pc98:sys/arch/i386/boot/asm.S
 * and netbsd_pc98:sys/arch/i386/boot/table.c
 */

/*
 * [NetBSD for NEC PC-98 series]
 *  Copyright (c) 1994, 1995, 1996, 1997, 1998, 1999
 *	NetBSD/pc98 porting staff. All rights reserved.
 */
/*
 * Ported to boot 386BSD by Julian Elischer (julian@tfs.com) Sept 1992
 *
 * Mach Operating System
 * Copyright (c) 1992, 1991 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

/*
  Copyright 1988, 1989, 1990, 1991, 1992 
   by Intel Corporation, Santa Clara, California.

                All Rights Reserved

Permission to use, copy, modify, and distribute this software and
its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appears in all
copies and that both the copyright notice and this permission notice
appear in supporting documentation, and that the name of Intel
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.

INTEL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL INTEL BE LIABLE FOR ANY SPECIAL, INDIRECT, OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <machine/asm.h>
#define	addr32	.byte 0x67
#define	data32	.byte 0x66
#include <machine/disklabel.h>

#include "bbinfo.h"

BOOTSEG		=	0x0100	# boot will be loaded here (below 640K)
BOOTSTACK	=	0xfffc	# boot stack
LOADSZ		=	PRIM_LOADSZ	# size of first loaded chunk

SIGNATURE	=	0xaa55
PARTSTART	=	DOSPARTOFF	# starting address of partition table
/*
 *	NBMRPART = 4 (PC/AT), 8 (PC-98) (see machine/disklabel.h)
 */
NUMPART		=	NDOSPART	# number of partitions in partition table

PARTSZ		=	16	# sizeof(struct dos_partition)
BOOTABLE	=	0x80	# value of dp_flag, means bootable partition

#include <machine/bootflags.h>

	.text
_C_LABEL(boot1):
ENTRY(start)
	jmp 1f				# 0
	# parameter headers
_C_LABEL(start_cylinder):
	.word	0			# 2 saved boot cylinder
	.ascii  "IPL1   "		# 4
	# boot loader paramters
	. = _C_LABEL(start) + BOOTFLAGS_DISK_OFFSET - 4
	.long	BOOTFLAGS_SIGNATURE		# 12
	.long	BOOTFLAGS_FLAGS_BIOSGEOM	# 16 flags
1:
	cli
	data32				# setup ds
	movl	$0,%eax
	mov     %ax,%ds
	movl	%eax,%ebp

	data32				# setup es
	movl	$BOOTSEG,%eax
	mov	%ax,%es

	mov	%ax,%ss			# setup stack
	data32
	movl	$BOOTSTACK, %esp

	addr32
	movl	%cs:_C_LABEL(start_cylinder),%eax
	orl	%eax,%eax
	jnz	crt_setup
	addr32
	movl	%ecx,%cs:_C_LABEL(start_cylinder)

	/*** 1) CRT SETUP ***/
crt_setup:
	addr32				# check has PEGC ?
	testb	$0x40,0x45c
	jz	1f

	movb	$0x30,%ah		# PC-9821 series ext graphic mode
	movb	$0x0c,%al
	movb	$0x32,%bh		# 31.5 khz, 30 lines, 640*480

	addr32				# if mate note with RAM disk
	testb   $0x80,0x400
	jnz     2f

	addr32				# if note keyboard
	testb   $0x8,0x481
	jnz     2f

	addr32 
	testb   $0x20,0x54c		# if mate 31k
	jnz	2f

1:
	movb	$0x42,%ah		# 400 dots
	movb	$0xc0,%ch
	int	$0x18

	data32				# 25 line
	movl	$0xa00,%eax
2:
	int	$0x18

	movb    $0x0c,%ah		# crt on
	int	$0x18

	xorl    %edx,%edx		# cursor home
	movb    $0x13,%ah
	int	$0x18

	movb    $0x11,%ah		# cursor on
	int	$0x18

	/*** 2) LOAD OUR BOOTCODE ***/
load_bootcode:
	# step I: loading the dospartition table
	movb	$0x06,%ah
	data32
	movl	$2048,%ebx		# blocksize minimum
	xorl	%ecx,%ecx
	xorl	%edx,%edx
	xorl	%ebp,%ebp

	addr32
	movb	0x584,%al
	andb    $0xf0,%al
	cmpb    $0x90,%al		# FD
	jz	3f
	cmpb    $0x30,%al		# 1.44 FD
	jz	3f
	jmp	4f

3:
	addr32	# fixup start_cylinder
	movl	%cs:_C_LABEL(start_cylinder),%eax
	xorb	%ah,%ah
	addr32
	movl	%eax,%cs:_C_LABEL(start_cylinder)

	movb	$0xd6,%ah
	incb	%dl
	movb	$2,%ch

4:
	addr32
	movb	0x584,%al
	data32
	int	$0x1b

	# step II: search our NetBSD entry (first hit)
	addr32
	movl	%cs:_C_LABEL(start_cylinder),%ebx

find_netbsd_partition:
	data32
	movl	$512,%ebp
	movb	$NUMPART,%ah		# ndospart
	jmp 	9f

1:
	data32
	addl	$32,%ebp
	decb	%ah
	jz	2f

9:
	addr32
	movb	%es:0(%ebp),%al
	andb	$0x7f,%al
	cmpb	$0x14,%al		# check mid
	jnz	1b
	addr32
	cmpb	$0xc4,%es:1(%ebp)	# check sid with active
	jnz	1b

	addr32
	movb	%es:8(%ebp),%dl		# sector
	addr32
	movb	%es:9(%ebp),%dh		# head
	addr32
	movl	%es:10(%ebp),%ecx	# cyl
	orl	%ebx,%ebx
	jz	slice_found
	cmpl	%ecx,%ebx
	jz	slice_found
	jmp	1b

2:	orl	%ebx,%ebx
	jz	slice_not_found
	xorl	%ebx,%ebx
	jmp	find_netbsd_partition

slice_not_found:
	xorl	%edx,%edx		# not found: assume 0:0:0
	xorl	%ecx,%ecx

slice_found: 	
	# step III: load our boot code
	pushl	%ecx
	movb	$0x06,%ah
	data32
	movl	$512*16,%ebx
	xorl	%ebp,%ebp

	addr32
	movb	0x584,%al
	andb    $0xf0,%al
	cmpb    $0x90,%al		# FD
	jz	3f
	cmpb    $0x30,%al		# 1.44 FD
	jz	3f
	jmp	4f
3:
	movb	$0xd6,%ah
	incb	%dl
	movb	$2,%ch
4:
	addr32
	movb	0x584,%al
	int	$0x1b
	popl	%ecx

	/*** 3) JUMP TO BOOT2 CODE ***/
#	copy bootparameter flags
	addr32
	movb	0x584,%dl

	data32
	xorl	%eax,%eax
	addr32
	data32
	movl	%cs:BOOTFLAGS_DISK_OFFSET(%eax),%esi
	addr32
	data32
	movl	%esi,BOOTFLAGS_BIOS_OFFSET

	addr32
	movl	%cs:_C_LABEL(start_cylinder),%esi

	data32
	ljmp	$BOOTSEG, $_C_LABEL(boot2)

/*
 * read_error
 */
read_error:
	data32
	movl	$eread, %esi
err_stop:
	data32
	call	message
	cli
	hlt

/*
 * message: write the error message in %ds:%esi to the console
 */
message:
	/*
	 * XXX: How about serial console ?
	 */
	data32
	pushl	%eax
	data32
	pushl	%ebx
	data32
	pushl	%edx
	pushl	%ds
	pushl	%es

	movl	%cs, %ax
	movl	%ax, %ds
	data32
	movl	$0xa000, %eax
	movl	%ax, %es
	data32
	xorl	%ebx, %ebx

nextb:
	cld
	lodsb			# load a byte into %al
	testb	%al, %al
	data32
	jz	done

	addr32
	movb	%al, %es:(%ebx)
	data32
	incl	%ebx
	data32
	incl	%ebx

	data32
	jmp	nextb

done:
	popl	%es
	popl	%ds
	data32
	popl	%edx
	data32
	popl	%ebx
	data32
	popl	%eax
	data32
	ret

eread:	.asciz		"Read err\r\n"
enoboot: .asciz		"No NetBSD part\r\n"
efail: .asciz		"Boot fail\r\n"

/* the last 2 bytes in the sector 0 contain the signature */
	. = _C_LABEL(boot1) + 0x1fe
	.short	SIGNATURE
	. = _C_LABEL(boot1) + 0x200
	.globl	_C_LABEL(disklabel)
_C_LABEL(disklabel):
	. = _C_LABEL(boot1) + 0x400
	.globl	_C_LABEL(booterstack)
_C_LABEL(booterstackbottom):
	. = _C_LABEL(boot1) + 0x1400
_C_LABEL(booterstack):

ENTRY(ourseg)
	.long	0
ENTRY(IPL_obootcylinder)
	.long	0
ENTRY(IPL_bootcylinder)
	.long	0
ENTRY(IPL_bootdevice)
	.long	0
ENTRY(rtcbuf)
	.long	0
	.long	0

/**************************************************************************
GLOBAL DESCRIPTOR TABLE
**************************************************************************/
	.align	4
gdt:
	.word	0, 0
	.byte	0, 0x00, 0x00, 0

#ifdef SUPPORT_LINUX	/* additional dummy */
	.word	0, 0
	.byte	0, 0x00, 0x00, 0
#endif

	/* kernel code segment */
	.globl flatcodeseg
flatcodeseg = . - gdt
	.word	0xffff, 0
	.byte	0, 0x9f, 0xcf, 0

	/* kernel data segment */
	.globl flatdataseg
flatdataseg = . - gdt
	.word	0xffff, 0
	.byte	0, 0x93, 0xcf, 0

	/* boot code segment, will be patched */
bootcodeseg = . - gdt
	.word	0xffff, 0
	.byte	0, 0x9e, 0x4f, 0

	/* boot data segment, will be patched */
bootdataseg = . - gdt
	.word	0xffff, 0
	.byte	0, 0x92, 0x0f, 0

	/* 16 bit real mode, will be patched */
bootrealseg = . - gdt
	.word	0xffff, 0
	.byte	0, 0x9e, 0x00, 0

	/* 16 bit real mode, boot data segment, will be patched */
bootrealdataseg = . - gdt
	.word	0xffff, 0
	.byte	0, 0x92, 0x00, 0
gdtlen = . - gdt

	.align	4
gdtarg:
	.word	gdtlen-1		/* limit */
	.long	0			/* addr, will be inserted */

_C_LABEL(boot2):
	data32
	xorl	%eax, %eax
	movl	%cs, %ax
	movl	%ax, %ds
	movl	%ax, %es
	addr32
	data32
	movl	%eax, _C_LABEL(ourseg)
	data32
	shll	$4, %eax

	/* fix up GDT entries for bootstrap */
#define FIXUP(gdt_index) \
	addr32; \
	movl	%eax, gdt+gdt_index+2;	/* actually movw %ax */ \
	addr32; \
	movb	%bl, gdt+gdt_index+4

	data32
	shldl	$16, %eax, %ebx

	FIXUP(bootcodeseg)
	FIXUP(bootrealseg)
	FIXUP(bootdataseg)

	/* fix up GDT pointer */
	data32
	addl	$gdt, %eax
	addr32
	data32
	movl	%eax, gdtarg+2

	/* change to protected mode */
	data32
	call	_C_LABEL(real_to_prot)

	movl	$_C_LABEL(booterstack), %esp
	andl	$0xffff,%esi
	movl	%esi, _C_LABEL(IPL_obootcylinder)
	andl	$0xffff,%ecx
	movl	%ecx, _C_LABEL(IPL_bootcylinder)
	movzbl	%dl, %edx	/* discard head (%dh) and random high bits */
	movl	%edx, _C_LABEL(IPL_bootdevice)
	pushl	%edx
	call	_C_LABEL(bootsectmain)
ENTRY(exit)
	call	_C_LABEL(prot_to_real)
	data32
	movl	$efail, %esi
	data32
	call	message

#ifdef notyet
	/* sleep for 3s = 0x2dc6c0 us */
	movb	$0x86, %ah
	data32
	movl	$0x002d, %ecx
	data32
	movl	$0xc6c0, %edx
	int	$0x15

	/* call ROM BASIC */
	int	$0x18
#else
	cli
	hlt
#endif

CR0_PE		=	0x1

/*
 * real_to_prot()
 * 	transfer from real mode to protected mode.
 */
ENTRY(real_to_prot)
	# guarantee that interrupt is disabled when in prot mode
	cli

	# load the gdtr
	addr32
	data32
	lgdt	gdtarg

	# set the PE bit of CR0
	movl	%cr0, %eax

	data32
	orl	$CR0_PE, %eax
	movl	%eax, %cr0 

	# make intrasegment jump to flush the processor pipeline and
	# reload CS register
	data32
	ljmp	$bootcodeseg, $xprot

xprot:
	# we are in USE32 mode now
	# set up the protected mode segment registers : DS, SS, ES
	movl	$bootdataseg, %eax
	movl	%ax, %ds
	movl	%ax, %ss
	movl	%ax, %es

	ret

/*
 * prot_to_real()
 * 	transfer from protected mode to real mode
 */
ENTRY(prot_to_real)
	# set up a dummy stack frame for the second seg change.
	# Adjust the intersegment jump instruction following 
	# the clearing of protected mode bit.
	# This is self-modifying code, but we need a writable
	# code segment, and an intersegment return does not give us that.

	mov	$bootrealdataseg, %eax
	movw    %ax, %es
	movw    %ax, %ds
	movw    %ax, %ss

	# Change to use16 mode.
	ljmp	$bootrealseg, $x16

x16:
	# clear the PE bit of CR0
	movl	%cr0, %eax
	data32
	andl 	$~CR0_PE, %eax
	movl	%eax, %cr0
	data32
	ljmp	$BOOTSEG, $xreal

xreal:
	# we are in real mode now
	# set up the real mode segment registers : DS, SS, ES
	movl	%cs, %ax
	movl	%ax, %ds
	movl	%ax, %ss
	movl	%ax, %es

	sti
	data32
	ret

/*
 * pbzero(dst, cnt)
 *	where dst is a physical address and cnt is the length
 */
ENTRY(pbzero)
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%es
	pushl	%edi

	cld

	# set %es to point at the flat segment
	movl	$flatdataseg, %eax
	movl	%ax, %es

	movl	8(%ebp), %edi		# destination
	movl	12(%ebp), %ecx		# count
	xorl	%eax, %eax		# value

	rep
	stosb

	popl	%edi
	popl	%es
	popl	%ebp
	ret

/*
 * vpbcopy(src, dst, cnt)
 *	where src is a virtual address and dst is a physical address
 */
ENTRY(vpbcopy)
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%es
	pushl	%esi
	pushl	%edi

	cld

	# set %es to point at the flat segment
	movl	$flatdataseg, %eax
	movl	%ax, %es

	movl	8(%ebp), %esi		# source
	movl	12(%ebp), %edi		# destination
	movl	16(%ebp), %ecx		# count

	rep
	movsb

	popl	%edi
	popl	%esi
	popl	%es
	popl	%ebp
	ret

/*
 * pvbcopy(src, dst, cnt)
 *	where src is a physical address and dst is a virtual address
 */
ENTRY(pvbcopy)
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ds
	pushl	%esi
	pushl	%edi

	cld

	# set %ds to point at the flat segment
	movl	$flatdataseg, %eax
	movl	%ax, %ds

	movl	8(%ebp), %esi		# source
	movl	12(%ebp), %edi		# destination
	movl	16(%ebp), %ecx		# count

	rep
	movsb

	popl	%edi
	popl	%esi
	popl	%ds
	popl	%ebp
	ret

ENTRY(vtophys)
	movl _C_LABEL(ourseg), %eax
	shll	$4, %eax
	addl 4(%esp), %eax
	ret
