#include "opt_config.h"

/*
 * Add either (or both) of
 *
 *	options INCLUDE_CONFIG_FILE
 *	options INCLUDE_JUST_CONFIG
 *
 * to your kernel config file to embed it in the resulting
 * kernel.  The latter option does not include files that are
 * included (recursively) by your config file.  The embedded
 * data be extracted by using the command:
 *
 *	strings netbsd | sed -n 's/^_CFG_//p' | unvis
 */

#ifdef CONFIG_FILE
#if defined(INCLUDE_CONFIG_FILE) || defined(INCLUDE_JUST_CONFIG)

static const char config[] __attribute__((__unused__)) =

#ifdef INCLUDE_CONFIG_FILE

"_CFG_### START CONFIG FILE \"KOHARU\"\n"

#endif /* INCLUDE_CONFIG_FILE */

"_CFG_# $NetBSD: GENERIC,v 1.515 2002/10/04 16:24:47 tsutsui Exp $\n"
"_CFG_#\n"
"_CFG_# GENERIC machine description file\n"
"_CFG_# \n"
"_CFG_# This machine description file is used to generate the default NetBSD\n"
"_CFG_# kernel.  The generic kernel does not include all options, subsystems\n"
"_CFG_# and device drivers, but should be useful for most applications.\n"
"_CFG_#\n"
"_CFG_# The machine description file can be customised for your specific\n"
"_CFG_# machine to reduce the kernel size and improve its performance.\n"
"_CFG_#\n"
"_CFG_# For further information on compiling NetBSD kernels, see the config(8)\n"
"_CFG_# man page.\n"
"_CFG_#\n"
"_CFG_# For further information on hardware support for this architecture, see\n"
"_CFG_# the intro(4) man page.  For further information about kernel options\n"
"_CFG_# for this architecture, see the options(4) man page.  For an explanation\n"
"_CFG_# of each device driver in this file see the section 4 man page for the\n"
"_CFG_# device.\n"
"_CFG_\n"
"_CFG_include \\011\"arch/pcat/conf/std.pcat\"\n"
"_CFG_\n"
"_CFG_options \\011INCLUDE_CONFIG_FILE\\011# embed config file in kernel binary\n"
"_CFG_\n"
"_CFG_#ident \\011\\011\"GENERIC-$Revision: 1.515 $\"\n"
"_CFG_\n"
"_CFG_maxusers\\01132\\011\\011# estimated number of users\n"
"_CFG_\n"
"_CFG_# CPU support.  At least one is REQUIRED.\n"
"_CFG_#options \\011I386_CPU\n"
"_CFG_#options \\011I486_CPU\n"
"_CFG_#options \\011I586_CPU\n"
"_CFG_options \\011I686_CPU\n"
"_CFG_\n"
"_CFG_# CPU-related options.\n"
"_CFG_#options \\011MATH_EMULATE\\011# floating point emulation\n"
"_CFG_options \\011VM86\\011\\011# virtual 8086 emulation\n"
"_CFG_options \\011USER_LDT\\011# user-settable LDT; used by WINE\n"
"_CFG_# eliminate delay no-ops in I/O; recommended on all but very old machines\n"
"_CFG_#options \\011DUMMY_NOPS\n"
"_CFG_\n"
"_CFG_options \\011MTRR\\011\\011# memory-type range register syscall support\n"
"_CFG_# doesn't work with MP just yet..\n"
"_CFG_#options \\011PERFCTRS\\011# performance-monitoring counters support\n"
"_CFG_\n"
"_CFG_# delay between \"rebooting ...\" message and hardware reset, in milliseconds\n"
"_CFG_options \\011CPURESET_DELAY=1000\n"
"_CFG_\n"
"_CFG_# This option allows you to force a serial console at the specified\n"
"_CFG_# I/O address.   see console(4) for details.\n"
"_CFG_#options \\011CONSDEVNAME=\"\\134\"com\\134\"\",CONADDR=0x2f8,CONSPEED=57600\n"
"_CFG_#\\011you don't want the option below ON iff you are using the\n"
"_CFG_#\\011serial console option of the new boot strap code.\n"
"_CFG_#options \\011CONS_OVERRIDE\\011# Always use above! independent of boot info\n"
"_CFG_\n"
"_CFG_# The following options override the memory sizes passed in from the boot\n"
"_CFG_# block.  Use them *only* if the boot block is unable to determine the correct\n"
"_CFG_# values.  Note that the BIOS may *correctly* report less than 640k of base\n"
"_CFG_# memory if the extended BIOS data area is located at the top of base memory\n"
"_CFG_# (as is the case on most recent systems).\n"
"_CFG_#options \\011REALBASEMEM=639\\011\\011# size of base memory (in KB)\n"
"_CFG_#options \\011REALEXTMEM=15360\\011# size of extended memory (in KB)\n"
"_CFG_\n"
"_CFG_# Standard system options\n"
"_CFG_\n"
"_CFG_options \\011UCONSOLE\\011# users can use TIOCCONS (for xconsole)\n"
"_CFG_options \\011INSECURE\\011# disable kernel security levels - X needs this\n"
"_CFG_\n"
"_CFG_options \\011RTC_OFFSET=-540\\011# hardware clock is this many mins. west of GMT\n"
"_CFG_options \\011NTP\\011\\011# NTP phase/frequency locked loop\n"
"_CFG_\n"
"_CFG_options \\011KTRACE\\011\\011# system call tracing via ktrace(1)\n"
"_CFG_options \\011SYSTRACE\\011# system call vetting via systrace(1)\n"
"_CFG_\n"
"_CFG_options \\011SYSVMSG\\011\\011# System V-like message queues\n"
"_CFG_options \\011SYSVSEM\\011\\011# System V-like semaphores\n"
"_CFG_#options \\011SEMMNI=10\\011# number of semaphore identifiers\n"
"_CFG_#options \\011SEMMNS=60\\011# number of semaphores in system\n"
"_CFG_#options \\011SEMUME=10\\011# max number of undo entries per process\n"
"_CFG_#options \\011SEMMNU=30\\011# number of undo structures in system\n"
"_CFG_options \\011SYSVSHM\\011\\011# System V-like memory sharing\n"
"_CFG_options \\011SHMMAXPGS=8192\\011# 2048 pages is the default\n"
"_CFG_\n"
"_CFG_options \\011LKM\\011\\011# loadable kernel modules\n"
"_CFG_\n"
"_CFG_options \\011USERCONF\\011# userconf(4) support\n"
"_CFG_#options \\011PIPE_SOCKETPAIR\\011# smaller, but slower pipe(2)\n"
"_CFG_\n"
"_CFG_# Enable experimental buffer queue strategy for better responsiness under\n"
"_CFG_# high disk I/O load. Use it with caution - it's not proven to be stable yet.\n"
"_CFG_options \\011NEW_BUFQ_STRATEGY\n"
"_CFG_\n"
"_CFG_# Diagnostic/debugging support options\n"
"_CFG_#options \\011DIAGNOSTIC\\011# expensive kernel consistency checks\n"
"_CFG_#options \\011DEBUG\\011\\011# expensive debugging checks/support\n"
"_CFG_#options \\011KMEMSTATS\\011# kernel memory statistics (vmstat -m)\n"
"_CFG_options \\011DDB\\011\\011# in-kernel debugger\n"
"_CFG_options \\011DDB_HISTORY_SIZE=512\\011# enable history editing in DDB\n"
"_CFG_#options \\011KGDB\\011\\011# remote debugger\n"
"_CFG_#options \\011KGDB_DEVNAME=\"\\134\"com\\134\"\",KGDB_DEVADDR=0x3f8,KGDB_DEVRATE=9600\n"
"_CFG_#makeoptions\\011DEBUG=\"-g\"\\011# compile full symbol table\n"
"_CFG_\n"
"_CFG_# Compatibility options\n"
"_CFG_#options \\011COMPAT_NOMID\\011# compatibility with 386BSD, BSDI, NetBSD 0.8,\n"
"_CFG_#options \\011COMPAT_09\\011# NetBSD 0.9,\n"
"_CFG_#options \\011COMPAT_10\\011# NetBSD 1.0,\n"
"_CFG_#options \\011COMPAT_11\\011# NetBSD 1.1,\n"
"_CFG_#options \\011COMPAT_12\\011# NetBSD 1.2,\n"
"_CFG_options \\011COMPAT_13\\011# NetBSD 1.3,\n"
"_CFG_options \\011COMPAT_14\\011# NetBSD 1.4,\n"
"_CFG_options \\011COMPAT_15\\011# NetBSD 1.5,\n"
"_CFG_options \\011COMPAT_43\\011# and 4.3BSD\n"
"_CFG_#options \\011COMPAT_386BSD_MBRPART # recognize old partition ID\n"
"_CFG_#options \\011TCP_COMPAT_42\\011# 4.2BSD TCP/IP bug compat. Not recommended.\n"
"_CFG_\n"
"_CFG_#options \\011COMPAT_SVR4\\011# binary compatibility with SVR4\n"
"_CFG_#options \\011COMPAT_IBCS2\\011# binary compatibility with SCO and ISC\n"
"_CFG_options \\011COMPAT_LINUX\\011# binary compatibility with Linux\n"
"_CFG_options \\011COMPAT_FREEBSD\\011# binary compatibility with FreeBSD\n"
"_CFG_#options \\011COMPAT_MACH\\011# binary compatibility with Mach binaries\n"
"_CFG_#options \\011EXEC_MACHO\\011# exec MACH-O binaries\n"
"_CFG_options \\011COMPAT_PECOFF\\011# kernel support to run Win32 apps\n"
"_CFG_\n"
"_CFG_# File systems\n"
"_CFG_file-system \\011FFS\\011\\011# UFS\n"
"_CFG_#file-system \\011EXT2FS\\011\\011# second extended file system (linux)\n"
"_CFG_#file-system \\011LFS\\011\\011# log-structured file system\n"
"_CFG_file-system \\011MFS\\011\\011# memory file system\n"
"_CFG_file-system \\011NFS\\011\\011# Network File System client\n"
"_CFG_#file-system \\011NTFS\\011\\011# Windows/NT file system (experimental)\n"
"_CFG_file-system \\011CD9660\\011\\011# ISO 9660 + Rock Ridge file system\n"
"_CFG_file-system \\011MSDOSFS\\011\\011# MS-DOS file system\n"
"_CFG_#file-system \\011FDESC\\011\\011# /dev/fd\n"
"_CFG_file-system \\011KERNFS\\011\\011# /kern\n"
"_CFG_file-system \\011NULLFS\\011\\011# loopback file system\n"
"_CFG_#file-system \\011OVERLAY\\011\\011# overlay file system\n"
"_CFG_#file-system \\011PORTAL\\011\\011# portal filesystem (still experimental)\n"
"_CFG_file-system \\011PROCFS\\011\\011# /proc\n"
"_CFG_#file-system \\011UMAPFS\\011\\011# NULLFS + uid and gid remapping\n"
"_CFG_file-system \\011UNION\\011\\011# union file system\n"
"_CFG_#file-system\\011CODA\\011\\011# Coda File System; also needs vcoda (below)\n"
"_CFG_\n"
"_CFG_# File system options\n"
"_CFG_#options \\011QUOTA\\011\\011# UFS quotas\n"
"_CFG_options \\011FFS_EI\\011\\011# FFS Endian Independent support\n"
"_CFG_options \\011SOFTDEP\\011\\011# FFS soft updates support.\n"
"_CFG_options \\011NFSSERVER\\011# Network File System server\n"
"_CFG_#options \\011EXT2FS_SYSTEM_FLAGS # makes ext2fs file flags (append and\n"
"_CFG_\\011\\011\\011\\011# immutable) behave as system flags.\n"
"_CFG_\n"
"_CFG_# Networking options\n"
"_CFG_#options \\011GATEWAY\\011\\011# packet forwarding\n"
"_CFG_options \\011INET\\011\\011# IP + ICMP + TCP + UDP\n"
"_CFG_#options \\011INET6\\011\\011# IPV6\n"
"_CFG_#options \\011IPSEC\\011\\011# IP security\n"
"_CFG_#options \\011IPSEC_ESP\\011# IP security (encryption part; define w/IPSEC)\n"
"_CFG_#options \\011IPSEC_DEBUG\\011# debug for IP security\n"
"_CFG_#options \\011MROUTING\\011# IP multicast routing\n"
"_CFG_#options \\011NS\\011\\011# XNS\n"
"_CFG_#options \\011NSIP\\011\\011# XNS tunneling over IP\n"
"_CFG_#options \\011ISO,TPIP\\011# OSI\n"
"_CFG_#options \\011EON\\011\\011# OSI tunneling over IP\n"
"_CFG_#options \\011CCITT,LLC,HDLC\\011# X.25\n"
"_CFG_#options \\011NETATALK\\011# AppleTalk networking protocols\n"
"_CFG_options \\011PPP_BSDCOMP\\011# BSD-Compress compression support for PPP\n"
"_CFG_options \\011PPP_DEFLATE\\011# Deflate compression support for PPP\n"
"_CFG_options \\011PPP_FILTER\\011# Active filter support for PPP (requires bpf)\n"
"_CFG_options \\011PFIL_HOOKS\\011# pfil(9) packet filter hooks\n"
"_CFG_options \\011IPFILTER_LOG\\011# ipmon(8) log support\n"
"_CFG_#options \\011IPFILTER_DEFAULT_BLOCK\\011# block all packets by default\n"
"_CFG_#options \\011TCP_DEBUG\\011# Record last TCP_NDEBUG packets with SO_DEBUG\n"
"_CFG_\n"
"_CFG_# These options enable verbose messages for several subsystems.\n"
"_CFG_# Warning, these may compile large string tables into the kernel!\n"
"_CFG_#options \\011EISAVERBOSE\\011# verbose EISA device autoconfig messages\n"
"_CFG_options \\011MIIVERBOSE\\011# verbose PHY autoconfig messages\n"
"_CFG_options \\011PCIVERBOSE\\011# verbose PCI device autoconfig messages\n"
"_CFG_#options \\011PCI_CONFIG_DUMP\\011# verbosely dump PCI config space\n"
"_CFG_options \\011PCMCIAVERBOSE\\011# verbose PCMCIA configuration messages\n"
"_CFG_options \\011SCSIVERBOSE\\011# human readable SCSI error messages\n"
"_CFG_options \\011USBVERBOSE\\011# verbose USB device autoconfig messages\n"
"_CFG_#options \\011PNPBIOSVERBOSE\\011# verbose PnP BIOS messages\n"
"_CFG_#options \\011PNPBIOSDEBUG\\011# more fulsome PnP BIOS debugging messages\n"
"_CFG_#options \\011I2OVERBOSE\\011# verbose I2O driver messages\n"
"_CFG_#options \\011MCAVERBOSE\\011# verbose MCA device autoconfig messages\n"
"_CFG_\n"
"_CFG_options \\011NFS_BOOT_DHCP,NFS_BOOT_BOOTPARAM\n"
"_CFG_\n"
"_CFG_#\n"
"_CFG_# wscons options\n"
"_CFG_#\n"
"_CFG_# builtin terminal emulations\n"
"_CFG_#options \\011WSEMUL_SUN\\011\\011# sun terminal emulation\n"
"_CFG_options \\011WSEMUL_VT100\\011\\011# VT100 / VT220 emulation\n"
"_CFG_# different kernel output - see dev/wscons/wsdisplayvar.h\n"
"_CFG_options \\011WS_KERNEL_FG=WSCOL_GREEN\n"
"_CFG_#options \\011WS_KERNEL_BG=WSCOL_BLACK\n"
"_CFG_# compatibility to other console drivers\n"
"_CFG_options \\011WSDISPLAY_COMPAT_PCVT\\011\\011# emulate some ioctls\n"
"_CFG_options \\011WSDISPLAY_COMPAT_SYSCONS\\011# emulate some ioctls\n"
"_CFG_options \\011WSDISPLAY_COMPAT_USL\\011\\011# VT handling\n"
"_CFG_options \\011WSDISPLAY_COMPAT_RAWKBD\\011\\011# can get raw scancodes\n"
"_CFG_# see dev/pckbc/wskbdmap_mfii.c for implemented layouts\n"
"_CFG_#options \\011PCKBD_LAYOUT=\"(KB_DE | KB_NODEAD)\"\n"
"_CFG_# allocate a number of virtual screens at autoconfiguration time\n"
"_CFG_#options \\011WSDISPLAY_DEFAULTSCREENS=4\n"
"_CFG_# use a large software cursor that doesn't blink\n"
"_CFG_options \\011PCDISPLAY_SOFTCURSOR\n"
"_CFG_# modify the screen type of the console; defaults to \"80x25\"\n"
"_CFG_#options \\011VGA_CONSOLE_SCREENTYPE=\"\\134\"80x24\\134\"\"\n"
"_CFG_# work around a hardware bug that loaded fonts don't work; found on ATI cards\n"
"_CFG_options \\011VGA_CONSOLE_ATI_BROKEN_FONTSEL\n"
"_CFG_# the following enables some functions to get mouse console support.\n"
"_CFG_# if you want a really secure system, it may be better not to enable them,\n"
"_CFG_# see wsmoused(8), section SECURITY CONSIDERATIONS for more info.\n"
"_CFG_options \\011WSDISPLAY_CHARFUNCS\\011\\011# mouse console support\n"
"_CFG_# enable VGA raster mode capable of displaying multilingual text on console\n"
"_CFG_#options \\011VGA_RASTERCONSOLE\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Kernel root file system and dump configuration.\n"
"_CFG_config\\011\\011netbsd\\011root on ? type ?\n"
"_CFG_#config\\011\\011netbsd\\011root on sd0a type ffs\n"
"_CFG_#config\\011\\011netbsd\\011root on ? type nfs\n"
"_CFG_\n"
"_CFG_#\n"
"_CFG_# Device configuration\n"
"_CFG_#\n"
"_CFG_\n"
"_CFG_mainbus0 at root\n"
"_CFG_\n"
"_CFG_cpu* at mainbus?\n"
"_CFG_#ioapic* at mainbus?\n"
"_CFG_\n"
"_CFG_apm0\\011at mainbus0\\011\\011\\011# Advanced power management\n"
"_CFG_\n"
"_CFG_# Tuning for power management, see apm(4) for more details.\n"
"_CFG_#options \\011APM_NO_IDLE\\011\\011# Don't call BIOS CPU idle function\n"
"_CFG_#options \\011APM_V10_ONLY\\011\\011# Use only the APM 1.0 calls\n"
"_CFG_#options \\011APM_NO_POWEROFF\\011\\011# Don't power off on halt(8)\n"
"_CFG_#options \\011APM_POWER_PRINT\\011\\011# Print stats on the console\n"
"_CFG_#options \\011APM_DISABLE_INTERRUPTS=0 # Don't disable interrupts\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Basic Bus Support\n"
"_CFG_\n"
"_CFG_# Plug-and-Play BIOS and attached devices\n"
"_CFG_\n"
"_CFG_#pnpbios*\\011at mainbus?\n"
"_CFG_\n"
"_CFG_# mainboard audio chips\n"
"_CFG_#ess*\\011\\011at pnpbios? index ?\\011# ESS AudioDrive\n"
"_CFG_#sb*\\011\\011at pnpbios? index ?\\011# NeoMagic 256AV in sb mode\n"
"_CFG_#wss*\\011\\011at pnpbios? index ?\\011# NeoMagic 256AV in wss mode\n"
"_CFG_#ym*\\011\\011at pnpbios? index ?\\011# OPL3-SA3\n"
"_CFG_\n"
"_CFG_# com port\n"
"_CFG_# If enabled, consider changing \"com0\", \"com1\", and \"com2\" under \"ISA Serial\n"
"_CFG_# Interfaces\" to \"com*\", otherwise com2 will attach at pnpbios? and there\n"
"_CFG_# will be no com0.  A side effect is pcmcia (and other) com? previously\n"
"_CFG_# starting at com3 may attach as com1 or com2.\n"
"_CFG_#com*\\011\\011at pnpbios? index ?\\011# serial ports\n"
"_CFG_\n"
"_CFG_# parallel port\n"
"_CFG_# The above \"com*\" comments apply, cf. \"lpt0\" under \"ISA parallel\n"
"_CFG_# \"printer interfaces\".\n"
"_CFG_#lpt*\\011\\011at pnpbios? index ?\\011# parallel ports\n"
"_CFG_\n"
"_CFG_#pckbc*\\011\\011at pnpbios? index ?\\011# PC keyboard/mouse controller\n"
"_CFG_#fdc*\\011\\011at pnpbios? index ?\\011# floppy controller\n"
"_CFG_\n"
"_CFG_# IDE controller on Toshiba Portege 3000 series (crippled PCI device)\n"
"_CFG_#pciide*\\011at pnpbios? index ?\n"
"_CFG_\n"
"_CFG_# PCI bus support\n"
"_CFG_pci*\\011at mainbus? bus ?\n"
"_CFG_pci*\\011at pchb? bus ?\n"
"_CFG_pci*\\011at ppb? bus ?\n"
"_CFG_\n"
"_CFG_# Configure PCI using BIOS information\n"
"_CFG_options \\011PCIBIOS\\011\\011\\011# PCI BIOS support\n"
"_CFG_#options \\011PCIBIOSVERBOSE\\011\\011# PCI BIOS verbose info\n"
"_CFG_options \\011PCIBIOS_ADDR_FIXUP\\011# fixup PCI I/O addresses\n"
"_CFG_options \\011PCIBIOS_BUS_FIXUP\\011# fixup PCI bus numbering\n"
"_CFG_options \\011PCIBIOS_INTR_FIXUP\\011# fixup PCI interrupt routing\n"
"_CFG_#options \\011PCIBIOS_IRQS_HINT=0x0a00 # PCI interrupts hint. IRQ 9 or 11\n"
"_CFG_options \\011PCIBIOS_INTR_GUESS\\011# see pcibios(4)\n"
"_CFG_#options \\011PCIINTR_DEBUG\\011\\011# super-verbose PCI interrupt fixup\n"
"_CFG_\n"
"_CFG_# System Controllers\n"
"_CFG_#elansc* at pci? dev ? function ?\\011# AMD Elan SC520 System Controller\n"
"_CFG_\n"
"_CFG_# PCI bridges\n"
"_CFG_pchb*\\011at pci? dev ? function ?\\011# PCI-Host bridges\n"
"_CFG_#pceb*\\011at pci? dev ? function ?\\011# PCI-EISA bridges\n"
"_CFG_pcib*\\011at pci? dev ? function ?\\011# PCI-ISA bridges\n"
"_CFG_#pcmb*\\011at pci? dev ? function ?\\011# PCI-MCA bridges\n"
"_CFG_ppb*\\011at pci? dev ? function ?\\011# PCI-PCI bridges\n"
"_CFG_# XXX 'puc's aren't really bridges, but there's no better place for them here\n"
"_CFG_#puc*\\011at pci? dev ? function ?\\011# PCI \"universal\" comm. cards\n"
"_CFG_\n"
"_CFG_agp* \\011at pchb?\n"
"_CFG_\n"
"_CFG_#\n"
"_CFG_\n"
"_CFG_#p64h2apic* at pci? dev? function?\\011# P64H2 IOxAPIC\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# EISA bus support\n"
"_CFG_#eisa0\\011at mainbus?\n"
"_CFG_#eisa0\\011at pceb?\n"
"_CFG_\n"
"_CFG_# ISA bus support\n"
"_CFG_#isa0\\011at mainbus?\n"
"_CFG_#isa0\\011at pceb?\n"
"_CFG_isa0\\011at pcib?\n"
"_CFG_\n"
"_CFG_# PCMCIA bus support\n"
"_CFG_#pcmcia*\\011at pcic? controller ? socket ?\n"
"_CFG_#pcmcia*\\011at tcic? controller ? socket ?\n"
"_CFG_\n"
"_CFG_# MCA bus support\n"
"_CFG_#mca0\\011at mainbus?\n"
"_CFG_\n"
"_CFG_# ISA PCMCIA controllers\n"
"_CFG_#pcic0\\011at isa? port 0x3e0 iomem 0xd0000 iosiz 0x10000\n"
"_CFG_#pcic1\\011at isa? port 0x3e2 iomem 0xe0000 iosiz 0x4000\n"
"_CFG_#pcic2\\011at isa? port 0x3e4 iomem 0xe0000 iosiz 0x4000\n"
"_CFG_#tcic0\\011at isa? port 0x240 iomem 0xd0000 iosiz 0x10000\n"
"_CFG_\n"
"_CFG_# PCI PCMCIA controllers\n"
"_CFG_#pcic0\\011at pci? dev? function ?\n"
"_CFG_\n"
"_CFG_# ISA Plug-and-Play bus support\n"
"_CFG_#isapnp0\\011at isa?\n"
"_CFG_\n"
"_CFG_# ISA Plug-and-Play PCMCIA controllers\n"
"_CFG_#pcic*\\011at isapnp?\n"
"_CFG_\n"
"_CFG_# CardBus bridge support\n"
"_CFG_cbb*\\011\\011at pci? dev ? function ?\n"
"_CFG_cardslot*\\011at cbb?\n"
"_CFG_\n"
"_CFG_# CardBus bus support\n"
"_CFG_cardbus*\\011at cardslot?\n"
"_CFG_pcmcia* \\011at cardslot?\n"
"_CFG_\n"
"_CFG_# Coprocessor Support\n"
"_CFG_\n"
"_CFG_# Math Coprocessor support\n"
"_CFG_npx0\\011at isa? port 0xf0 irq 13\\011# x86 math coprocessor\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Console Devices\n"
"_CFG_\n"
"_CFG_# ISA console\n"
"_CFG_#pc0\\011at isa? port 0x60 irq 1\\011\\011# pccons generic PC console driver\n"
"_CFG_# Keyboard layout configuration for pccons\n"
"_CFG_#options \\011FRENCH_KBD\n"
"_CFG_#options \\011FINNISH_KBD\n"
"_CFG_#options \\011GERMAN_KBD\n"
"_CFG_#options \\011NORWEGIAN_KBD\n"
"_CFG_# pccons-specific options:\n"
"_CFG_#options \\011XSERVER_DDB\\011# PF12 gets you into DDB when X is running\n"
"_CFG_#options \\011XSERVER\\011\\011# X server support\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# wscons\n"
"_CFG_pckbc0\\011\\011at isa?\\011\\011\\011# pc keyboard controller\n"
"_CFG_pckbd*\\011\\011at pckbc?\\011\\011# PC keyboard\n"
"_CFG_pms*\\011\\011at pckbc?\\011\\011# PS/2 mouse for wsmouse\n"
"_CFG_#options \\011PMS_DISABLE_POWERHOOK\\011# Disable PS/2 reset on resume\n"
"_CFG_#vga0\\011\\011at isa?\n"
"_CFG_vga*\\011\\011at pci? dev ? function ?\n"
"_CFG_#pcdisplay0\\011at isa?\\011\\011\\011# CGA, MDA, EGA, HGA\n"
"_CFG_wsdisplay*\\011at vga? console ?\n"
"_CFG_#wsdisplay*\\011at pcdisplay? console ?\n"
"_CFG_wskbd*\\011\\011at pckbd? console ?\n"
"_CFG_wsmouse*\\011at pms? mux 0\n"
"_CFG_\n"
"_CFG_pcppi0\\011\\011at isa?\n"
"_CFG_sysbeep0\\011at pcppi?\n"
"_CFG_\n"
"_CFG_# Serial Devices\n"
"_CFG_\n"
"_CFG_# PCI serial interfaces\n"
"_CFG_#com*\\011at puc? port ?\\011\\011\\011# 16x50s on \"universal\" comm boards\n"
"_CFG_#cy*\\011at pci? dev ? function ?\\011# Cyclades Cyclom-Y serial boards\n"
"_CFG_#cz*\\011at pci? dev ? function ?\\011# Cyclades-Z multi-port serial boards\n"
"_CFG_\n"
"_CFG_# ISA Plug-and-Play serial interfaces\n"
"_CFG_#com*\\011at isapnp?\\011\\011\\011# Modems and serial boards\n"
"_CFG_\n"
"_CFG_# PCMCIA serial interfaces\n"
"_CFG_com*\\011at pcmcia? function ?\\011\\011# Modems and serial cards\n"
"_CFG_\n"
"_CFG_#pcmcom*\\011at pcmcia? function ?\\011\\011# PCMCIA multi-port serial cards\n"
"_CFG_#com*\\011at pcmcom? slave ?\\011\\011# ...and the slave devices\n"
"_CFG_\n"
"_CFG_# CardBus serial interfaces\n"
"_CFG_#com*\\011at cardbus? dev ? function ?\\011# Modems and serial cards\n"
"_CFG_\n"
"_CFG_# ISA serial interfaces\n"
"_CFG_#options \\011COM_HAYESP\\011\\011# adds Hayes ESP serial board support\n"
"_CFG_#com0\\011at isa? port 0x3f8 irq 4\\011# Standard PC serial ports\n"
"_CFG_#com1\\011at isa? port 0x2f8 irq 3\n"
"_CFG_#com2\\011at isa? port 0x3e8 irq 5\n"
"_CFG_#com3\\011at isa? port 0x2e8 irq 9\n"
"_CFG_#ast0\\011at isa? port 0x1a0 irq 5\\011# AST 4-port serial cards\n"
"_CFG_#com*\\011at ast? slave ?\n"
"_CFG_#boca0\\011at isa? port 0x100 irq 5\\011# BOCA 8-port serial cards\n"
"_CFG_#boca0\\011at isa? port 0x100 irq 5\\011# BOCA 16-port serial cards (BB2016)\n"
"_CFG_#boca1\\011at isa? port 0x140 irq 5\\011# this line is also needed for BB2016\n"
"_CFG_#com*\\011at boca? slave ?\n"
"_CFG_#tcom0\\011at isa? port 0x100 irq 7\\011# TC-800 8-port serial cards\n"
"_CFG_#com*\\011at tcom? slave ?\n"
"_CFG_#rtfps0\\011at isa? port 0x1230 irq 10\\011# RT 4-port serial cards\n"
"_CFG_#com*\\011at rtfps? slave ?\n"
"_CFG_#cy0\\011at isa? iomem 0xd4000 irq 12\\011# Cyclades serial cards\n"
"_CFG_#addcom0 at isa? port 0x108 irq 5\\011# Addonics FlexPort 8S\n"
"_CFG_#com*\\011at addcom? slave ?\n"
"_CFG_#moxa0\\011at isa?\\011port 0x100 irq 5\\011# MOXA C168H serial card (experimental)\n"
"_CFG_#com*\\011at moxa? slave ?\n"
"_CFG_\n"
"_CFG_# MCA serial interfaces\n"
"_CFG_#com*\\011at mca? slot ?\\011\\011\\011# 16x50s on comm boards\n"
"_CFG_\n"
"_CFG_# Parallel Printer Interfaces\n"
"_CFG_\n"
"_CFG_# PCI parallel printer interfaces\n"
"_CFG_#lpt*\\011at puc? port ?\\011\\011\\011# || ports on \"universal\" comm boards\n"
"_CFG_\n"
"_CFG_# ISA parallel printer interfaces\n"
"_CFG_#lpt0\\011at isa? port 0x378 irq 7\\011# standard PC parallel ports\n"
"_CFG_#lpt1\\011at isa? port 0x278\n"
"_CFG_#lpt2\\011at isa? port 0x3bc\n"
"_CFG_\n"
"_CFG_# Hardware monitors\n"
"_CFG_\n"
"_CFG_# LM7[89] and compatible hardware monitors\n"
"_CFG_#lm0\\011at isa?\\011port 0x290\\011\\011# other common ports: 0x280, 0x310\n"
"_CFG_\n"
"_CFG_# VIA VT82C686A hardware monitor\n"
"_CFG_#viapm*\\011at pci? dev ? function ?\n"
"_CFG_#viaenv* at viapm?\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# I2O devices\n"
"_CFG_#iop*\\011at pci? dev ? function ?\\011# I/O processor\n"
"_CFG_#iopsp*\\011at iop? tid ?\\011\\011\\011# SCSI/FC-AL ports\n"
"_CFG_#ld*\\011at iop? tid ?\\011\\011\\011# block devices\n"
"_CFG_#dpti*\\011at iop? tid 0\\011\\011\\011# DPT/Adaptec control interface\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# SCSI Controllers and Devices\n"
"_CFG_\n"
"_CFG_# PCI SCSI controllers\n"
"_CFG_#adv*\\011at pci? dev ? function ?\\011# AdvanSys 1200[A,B], 9xx[U,UA] SCSI\n"
"_CFG_#adw*\\011at pci? dev ? function ?\\011# AdvanSys 9x0UW[D], 3940U[2,3]W SCSI\n"
"_CFG_#ahc*\\011at pci? dev ? function ?\\011# Adaptec [23]94x, aic78x0 SCSI\n"
"_CFG_#bha*\\011at pci? dev ? function ?\\011# BusLogic 9xx SCSI\n"
"_CFG_#dpt*\\011at pci? dev ? function ?\\011# DPT SmartCache/SmartRAID\n"
"_CFG_#iha*\\011at pci? dev ? function ?\\011# Initio INIC-940/950 SCSI\n"
"_CFG_#isp*\\011at pci? dev ? function ?\\011# Qlogic ISP [12]0x0 SCSI/FibreChannel\n"
"_CFG_#mly*\\011at pci? dev ? function ?\\011# Mylex AcceleRAID and eXtremeRAID\n"
"_CFG_#pcscp*\\011at pci? dev ? function ?\\011# AMD 53c974 PCscsi-PCI SCSI\n"
"_CFG_#siop*\\011at pci? dev ? function ?\\011# Symbios 53c8xx SCSI\n"
"_CFG_#options \\011SIOP_SYMLED\\011\\011# drive the act. LED in software\n"
"_CFG_#trm*\\011at pci? dev ? function ?\\011# Tekram DC-395U/UW/F, DC-315/U SCSI\n"
"_CFG_\n"
"_CFG_# EISA SCSI controllers\n"
"_CFG_#ahb*\\011at eisa? slot ?\\011\\011\\011# Adaptec 174[02] SCSI\n"
"_CFG_#ahc*\\011at eisa? slot ?\\011\\011\\011# Adaptec 274x, aic7770 SCSI\n"
"_CFG_#bha*\\011at eisa? slot ?\\011\\011\\011# BusLogic 7xx SCSI\n"
"_CFG_#dpt*\\011at eisa? slot ?\\011\\011\\011# DPT EATA SCSI\n"
"_CFG_#uha*\\011at eisa? slot ?\\011\\011\\011# UltraStor 24f SCSI\n"
"_CFG_\n"
"_CFG_# PCMCIA SCSI controllers\n"
"_CFG_aic*\\011at pcmcia? function ?\\011\\011# Adaptec APA-1460 SCSI\n"
"_CFG_#esp*\\011at pcmcia? function ?\\011\\011# Qlogic ESP406/FAS408 SCSI\n"
"_CFG_\n"
"_CFG_# ISA Plug-and-Play SCSI controllers\n"
"_CFG_#aha*\\011at isapnp? \\011\\011\\011# Adaptec AHA-154[02\n"
"_CFG_#aic*\\011at isapnp?\\011\\011\\011# Adaptec AHA-1520B\n"
"_CFG_\n"
"_CFG_# ISA SCSI controllers\n"
"_CFG_#adv0\\011at isa? port ? irq ? drq ?\\011# AdvanSys APB-514[02] SCSI\n"
"_CFG_#aha0\\011at isa? port 0x330 irq ? drq ?\\011# Adaptec 154[02] SCSI\n"
"_CFG_#aha1\\011at isa? port 0x334 irq ? drq ?\n"
"_CFG_#ahc0\\011at isa? port ? irq ?\\011\\011# Adaptec 284x SCSI\n"
"_CFG_#aic0\\011at isa? port 0x340 irq 11\\011# Adaptec 152[02] SCSI\n"
"_CFG_#bha0\\011at isa? port 0x330 irq ? drq ?\\011# BusLogic [457]4X SCSI\n"
"_CFG_#bha1\\011at isa? port 0x334 irq ? drq ?\n"
"_CFG_# The \"nca\" and \"dpt\" probes might give false hits or hang your machine.\n"
"_CFG_#dpt0\\011at isa? port 0x170 irq ? drq ?\\011# DPT SmartCache/SmartRAID\n"
"_CFG_#nca0\\011at isa? port 0x360 irq 15\\011# Port-mapped NCR 53C80 controller\n"
"_CFG_#nca1\\011at isa? iomem 0xd8000 irq 5\\011# Memory-mapped controller (T128, etc.)\n"
"_CFG_#sea0\\011at isa? iomem 0xc8000 irq 5\\011# Seagate/Future Domain SCSI\n"
"_CFG_#uha0\\011at isa? port 0x330 irq ? drq ?\\011# UltraStor [13]4f SCSI\n"
"_CFG_#uha1\\011at isa? port 0x340 irq ? drq ?\n"
"_CFG_#wds0\\011at isa? port 0x350 irq 15 drq 6\\011# WD7000 and TMC-7000 controllers\n"
"_CFG_#wds1\\011at isa? port 0x358 irq 11 drq 5\n"
"_CFG_\n"
"_CFG_# CardBus SCSI cards\n"
"_CFG_#adv*\\011at cardbus? dev ? function ?\\011# AdvanSys 1200[A,B], 9xx[U,UA] SCSI\n"
"_CFG_#ahc*\\011at cardbus? dev ? function ?\\011# Adaptec ADP-1480\n"
"_CFG_\n"
"_CFG_# MCA SCSI cards\n"
"_CFG_#aha*\\011at mca? slot ?\\011\\011\\011# Adaptec AHA-1640\n"
"_CFG_\n"
"_CFG_# SCSI bus support\n"
"_CFG_scsibus* at scsi?\n"
"_CFG_\n"
"_CFG_# SCSI devices\n"
"_CFG_sd*\\011at scsibus? target ? lun ?\\011# SCSI disk drives\n"
"_CFG_st*\\011at scsibus? target ? lun ?\\011# SCSI tape drives\n"
"_CFG_cd*\\011at scsibus? target ? lun ?\\011# SCSI CD-ROM drives\n"
"_CFG_#ch*\\011at scsibus? target ? lun ?\\011# SCSI autochangers\n"
"_CFG_#ses*\\011at scsibus? target ? lun ?\\011# SCSI Enclosure Services devices\n"
"_CFG_#ss*\\011at scsibus? target ? lun ?\\011# SCSI scanners\n"
"_CFG_#uk*\\011at scsibus? target ? lun ?\\011# SCSI unknown\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# RAID controllers and devices\n"
"_CFG_#aac*\\011at pci? dev ? function ?\\011# Adaptec AAC family\n"
"_CFG_#cac*\\011at eisa? slot ?\\011\\011\\011# Compaq EISA array controllers\n"
"_CFG_#cac*\\011at pci? dev ? function ?\\011# Compaq PCI array controllers\n"
"_CFG_#icp*\\011at pci? dev ? function ?\\011# ICP-Vortex GDT & Intel RAID\n"
"_CFG_#mlx*\\011at pci? dev ? function ?\\011# Mylex DAC960 & DEC SWXCR family\n"
"_CFG_#mlx*\\011at eisa? slot ?\\011\\011\\011# Mylex DAC960 & DEC SWXCR family\n"
"_CFG_#twe*\\011at pci? dev ? function ?\\011# 3ware Escalade RAID controllers\n"
"_CFG_\n"
"_CFG_#ld*\\011at aac? unit ?\\011\\011\\011# logical disk devices\n"
"_CFG_#ld*\\011at cac? unit ?\n"
"_CFG_#ld*\\011at icp? unit ?\n"
"_CFG_#ld*\\011at twe? unit ?\n"
"_CFG_#ld*\\011at mlx? unit ?\n"
"_CFG_\n"
"_CFG_#icpsp*\\011at icp? unit ?\\011\\011\\011# SCSI pass-through\n"
"_CFG_\n"
"_CFG_# IDE and related devices\n"
"_CFG_# PCI IDE controllers - see pciide(4) for supported hardware.\n"
"_CFG_# The 0x0001 flag force the driver to use DMA, even if the driver doesn't know\n"
"_CFG_# how to set up DMA modes for this chip. This may work, or may cause\n"
"_CFG_# a machine hang with some controllers.\n"
"_CFG_pciide* at pci? dev ? function ? flags 0x0000\n"
"_CFG_\n"
"_CFG_# ISA Plug-and-Play IDE controllers\n"
"_CFG_#wdc*\\011at isapnp?\n"
"_CFG_\n"
"_CFG_# PCMCIA IDE controllers\n"
"_CFG_wdc*\\011at pcmcia? function ?\n"
"_CFG_\n"
"_CFG_# ISA ST506, ESDI, and IDE controllers\n"
"_CFG_# Use flags 0x01 if you want to try to use 32bits data I/O (the driver will\n"
"_CFG_# fall back to 16bits I/O if 32bits I/O are not functional).\n"
"_CFG_# Some controllers pass the initial 32bit test, but will fail later.\n"
"_CFG_#wdc0\\011at isa? port 0x1f0 irq 14 flags 0x00\n"
"_CFG_#wdc1\\011at isa? port 0x170 irq 15 flags 0x00\n"
"_CFG_\n"
"_CFG_# IDE drives\n"
"_CFG_# Flags are used only with controllers that support DMA operations\n"
"_CFG_# and mode settings (e.g. some pciide controllers)\n"
"_CFG_# The lowest order four bits (rightmost digit) of the flags define the PIO\n"
"_CFG_# mode to use, the next set of four bits the DMA mode and the third set the\n"
"_CFG_# UltraDMA mode. For each set of four bits, the 3 lower bits define the mode\n"
"_CFG_# to use, and the last bit must be 1 for this setting to be used.\n"
"_CFG_# For DMA and UDMA, 0xf (1111) means 'disable'.\n"
"_CFG_# 0x0fac means 'use PIO mode 4, DMA mode 2, disable UltraDMA'.\n"
"_CFG_# (0xc=1100, 0xa=1010, 0xf=1111)\n"
"_CFG_# 0x0000 means \"use whatever the drive claims to support\".\n"
"_CFG_wd*\\011at wdc? channel ? drive ? flags 0x0000\n"
"_CFG_wd*\\011at pciide? channel ? drive ? flags 0x0000\n"
"_CFG_\n"
"_CFG_# ATAPI bus support\n"
"_CFG_atapibus* at atapi?\n"
"_CFG_\n"
"_CFG_# ATAPI devices\n"
"_CFG_# flags have the same meaning as for IDE drives.\n"
"_CFG_cd*\\011at atapibus? drive ? flags 0x0000\\011# ATAPI CD-ROM drives\n"
"_CFG_sd*\\011at atapibus? drive ? flags 0x0000\\011# ATAPI disk drives\n"
"_CFG_st*\\011at atapibus? drive ? flags 0x0000\\011# ATAPI tape drives\n"
"_CFG_uk*\\011at atapibus? drive ? flags 0x0000\\011# ATAPI unknown\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Miscellaneous mass storage devices\n"
"_CFG_\n"
"_CFG_# ISA floppy\n"
"_CFG_#fdc0\\011at isa? port 0x3f0 irq 6 drq 2\\011# standard PC floppy controllers\n"
"_CFG_#fdc1\\011at isa? port 0x370 irq ? drq ?\n"
"_CFG_#fd*\\011at fdc? drive ?\\011\\011\\011# the drives themselves\n"
"_CFG_# some machines need you to do this instead of fd*\n"
"_CFG_#fd0\\011at fdc0 drive 0\n"
"_CFG_\n"
"_CFG_# ISA CD-ROM devices\n"
"_CFG_#mcd0\\011at isa? port 0x300 irq 10\\011# Mitsumi CD-ROM drives\n"
"_CFG_\n"
"_CFG_# ISA tape devices\n"
"_CFG_# note: the wt driver conflicts unpleasantly with SMC boards at the\n"
"_CFG_# same I/O address. The probe reprograms their EEPROMs. Don't\n"
"_CFG_# uncomment it unless you are actually using it.\n"
"_CFG_#wt0\\011at isa? port 0x308 irq 5 drq 1\\011# Archive and Wangtek QIC tape drives\n"
"_CFG_\n"
"_CFG_# MCA ESDI devices\n"
"_CFG_#edc*\\011at mca? slot ?\\011\\011\\011# IBM ESDI Disk Controllers\n"
"_CFG_#ed*\\011at edc?\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Network Interfaces\n"
"_CFG_\n"
"_CFG_# PCI network interfaces\n"
"_CFG_#an*\\011at pci? dev ? function ?\\011# Aironet PC4500/PC4800 (802.11)\n"
"_CFG_#bge* \\011at pci? dev ? function ?\\011# Broadcom 570x gigabit Ethernet\n"
"_CFG_#en*\\011at pci? dev ? function ?\\011# ENI/Adaptec ATM\n"
"_CFG_#ep*\\011at pci? dev ? function ?\\011# 3Com 3c59x\n"
"_CFG_#epic*\\011at pci? dev ? function ?\\011# SMC EPIC/100 Ethernet\n"
"_CFG_#esh*\\011at pci? dev ? function ?\\011# Essential HIPPI card\n"
"_CFG_#ex*\\011at pci? dev ? function ?\\011# 3Com 90x[BC]\n"
"_CFG_#fpa*\\011at pci? dev ? function ?\\011# DEC DEFPA FDDI\n"
"_CFG_fxp*\\011at pci? dev ? function ?\\011# Intel EtherExpress PRO 10+/100B\n"
"_CFG_#gsip*\\011at pci? dev ? function ?\\011# NS83820 Gigabit Ethernet\n"
"_CFG_#hme*\\011at pci? dev ? function ?\\011# Sun Microelectronics STP2002-STQ\n"
"_CFG_#le*\\011at pci? dev ? function ?\\011# PCnet-PCI Ethernet\n"
"_CFG_#lmc*\\011at pci? dev ? function ?\\011# Lan Media Corp SSI/HSSI/DS3\n"
"_CFG_#ne*\\011at pci? dev ? function ?\\011# NE2000-compatible Ethernet\n"
"_CFG_#ntwoc*\\011at pci? dev ? function ?\\011# Riscom/N2 PCI Sync Serial\n"
"_CFG_#pcn*\\011at pci? dev ? function ?\\011# AMD PCnet-PCI Ethernet\n"
"_CFG_#rtk*\\011at pci? dev ? function ?\\011# Realtek 8129/8139\n"
"_CFG_#sf*\\011at pci? dev ? function ?\\011# Adaptec AIC-6915 Ethernet\n"
"_CFG_#sip*\\011at pci? dev ? function ?\\011# SiS 900/DP83815 Ethernet\n"
"_CFG_#ste*\\011at pci? dev ? function ?\\011# Sundance ST-201 Ethernet\n"
"_CFG_#stge*\\011at pci? dev ? function ?\\011# Sundance/Tamarack TC9021 Gigabit\n"
"_CFG_#ti*\\011at pci? dev ? function ?\\011# Alteon ACEnic gigabit Ethernet\n"
"_CFG_#tl*\\011at pci? dev ? function ?\\011# ThunderLAN-based Ethernet\n"
"_CFG_#tlp*\\011at pci? dev ? function ?\\011# DECchip 21x4x and clones\n"
"_CFG_#vr*\\011at pci? dev ? function ?\\011# VIA Rhine Fast Ethernet\n"
"_CFG_#wi*\\011at pci? dev ? function ?\\011# Intersil Prism Mini-PCI (802.11b)\n"
"_CFG_#wm*\\011at pci? dev ? function ?\\011# Intel 82543/82544 gigabit\n"
"_CFG_\n"
"_CFG_# EISA network interfaces\n"
"_CFG_#ep*\\011at eisa? slot ?\\011\\011\\011# 3Com 3c579 Ethernet\n"
"_CFG_#fea*\\011at eisa? slot ?\\011\\011\\011# DEC DEFEA FDDI\n"
"_CFG_#tlp*\\011at eisa? slot ?\\011\\011\\011# DEC DE-425 Ethernet\n"
"_CFG_\n"
"_CFG_# ISA Plug-and-Play network interfaces\n"
"_CFG_#an*\\011at isapnp?\\011\\011\\011# Aironet 802.11\n"
"_CFG_#ep*\\011at isapnp?\\011\\011\\011# 3Com 3c509 Ethernet\n"
"_CFG_#le*\\011at isapnp?\\011\\011\\011# AMD PCnet-ISA Ethernet\n"
"_CFG_#ne*\\011at isapnp?\\011\\011\\011# NE2000-compatible Ethernet\n"
"_CFG_#tr*\\011at isapnp?\\011\\011\\011# IBM/3COM TROPIC Token-Ring\n"
"_CFG_\n"
"_CFG_# PCMCIA network interfaces\n"
"_CFG_#an*\\011at pcmcia? function ?\\011\\011# Aironet PC4500/PC4800 (802.11)\n"
"_CFG_#awi*\\011at pcmcia? function ?\\011\\011# BayStack 650/660 (802.11FH/DS)\n"
"_CFG_#cnw*\\011at pcmcia? function ?\\011\\011# Xircom/Netwave AirSurfer\n"
"_CFG_ep*\\011at pcmcia? function ?\\011\\011# 3Com 3c589 and 3c562 Ethernet\n"
"_CFG_mbe*\\011at pcmcia? function ?\\011\\011# MB8696x based Ethernet\n"
"_CFG_ne*\\011at pcmcia? function ?\\011\\011# NE2000-compatible Ethernet\n"
"_CFG_#ray*\\011at pcmcia? function ?\\011\\011# Raytheon Raylink (802.11)\n"
"_CFG_#sm*\\011at pcmcia? function ?\\011\\011# Megahertz Ethernet\n"
"_CFG_# tr at pcmcia has problems with Cardbus bridges\n"
"_CFG_#tr*\\011at pcmcia? function ?\\011\\011# TROPIC based Token-Ring\n"
"_CFG_wi*\\011at pcmcia? function ?\\011\\011# Lucent/Intersil WaveLan IEEE (802.11)\n"
"_CFG_#xi*\\011at pcmcia? function ?\\011\\011# Xircom CreditCard Ethernet\n"
"_CFG_\n"
"_CFG_#mhzc*\\011at pcmcia? function ?\\011\\011# Megahertz Ethernet/Modem combo cards\n"
"_CFG_#com*\\011at mhzc?\n"
"_CFG_#sm*\\011at mhzc?\n"
"_CFG_\n"
"_CFG_# ISA network interfaces\n"
"_CFG_#ate0\\011at isa? port 0x2a0 irq ?\\011\\011# AT1700\n"
"_CFG_#cs0\\011at isa? port 0x300 iomem ? irq ? drq ?\\011# CS8900 Ethernet\n"
"_CFG_#ec0\\011at isa? port 0x250 iomem 0xd8000 irq 9\\011# 3Com 3c503 Ethernet\n"
"_CFG_#eg0\\011at isa? port 0x280 irq 9\\011\\011# 3C505 ethernet cards\n"
"_CFG_#el0\\011at isa? port 0x300 irq 9\\011\\011# 3C501 ethernet cards\n"
"_CFG_#ep*\\011at isa? port ? irq ?\\011\\011\\011# 3C509 ethernet cards\n"
"_CFG_#ef0\\011at isa? port 0x360 iomem 0xd0000 irq 7\\011# 3C507\n"
"_CFG_#ai0\\011at isa? port 0x360 iomem 0xd0000 irq 7\\011# StarLAN\n"
"_CFG_#fmv0\\011at isa? port 0x2a0 irq ?\\011\\011# FMV-180 series\n"
"_CFG_#ix0\\011at isa? port 0x300 irq 10\\011\\011# EtherExpress/16\n"
"_CFG_#iy0\\011at isa? port 0x360 irq ?\\011\\011# EtherExpress PRO 10 ISA\n"
"_CFG_#lc0\\011at isa? port 0x320 iomem ? irq ?\\011# DEC EtherWORKS III (LEMAC)\n"
"_CFG_#depca0\\011at isa? port 0x300 iomem 0xc8000 iosiz 0x8000 irq 5\\011# DEPCA\n"
"_CFG_#le*\\011at depca?\n"
"_CFG_#nele0\\011at isa? port 0x320 irq 9 drq 7\\011\\011# NE2100\n"
"_CFG_#le*\\011at nele?\n"
"_CFG_#ntwoc0\\011at isa? port 0x300 irq 5 iomem 0xc8000 flags 1\\011# Riscom/N2 sync serial\n"
"_CFG_#bicc0\\011at isa? port 0x320 irq 10 drq 7\\011\\011# BICC IsoLan\n"
"_CFG_#le*\\011at bicc?\n"
"_CFG_#ne0\\011at isa? port 0x280 irq 9\\011\\011# NE[12]000 ethernet cards\n"
"_CFG_#ne1\\011at isa? port 0x300 irq 10\n"
"_CFG_#sm0\\011at isa? port 0x300 irq 10\\011\\011# SMC91C9x Ethernet\n"
"_CFG_#tr0\\011at isa? port 0xa20 iomem 0xd8000 irq ?\\011# IBM TROPIC based Token-Ring\n"
"_CFG_#tr1\\011at isa? port 0xa24 iomem 0xd0000 irq ?\\011# IBM TROPIC based Token-Ring\n"
"_CFG_#tr*\\011at isa? port ? irq ?\\011\\011\\011# 3COM TROPIC based Token-Ring\n"
"_CFG_#we0\\011at isa? port 0x280 iomem 0xd0000 irq 9\\011# WD/SMC Ethernet\n"
"_CFG_#we1\\011at isa? port 0x300 iomem 0xcc000 irq 10\n"
"_CFG_\n"
"_CFG_# CardBus network cards\n"
"_CFG_ex*\\011at cardbus? dev ? function ?\\011# 3Com 3C575TX\n"
"_CFG_fxp*\\011at cardbus? dev ? function ?\\011# Intel i8255x\n"
"_CFG_rtk*\\011at cardbus? dev ? function ?\\011# Realtek 8129/8139\n"
"_CFG_tlp*\\011at cardbus? dev ? function ?\\011# DECchip 21143\n"
"_CFG_\n"
"_CFG_# MCA network cards\n"
"_CFG_#elmc*\\011at mca? slot ?\\011\\011\\011# 3Com EtherLink/MC (3c523)\n"
"_CFG_#ep*\\011at mca? slot ?\\011\\011\\011# 3Com EtherLink III (3c529)\n"
"_CFG_#we*\\011at mca? slot ?\\011\\011\\011# WD/SMC Ethernet\n"
"_CFG_#ate*\\011at mca? slot ?\\011\\011\\011# Allied Telesis AT1720\n"
"_CFG_#ne*\\011at mca? slot ?\\011\\011\\011# Novell NE/2 and clones\n"
"_CFG_#tr*\\011at mca? slot ?\\011\\011\\011# IBM Token Ring adapter\n"
"_CFG_#le*\\011at mca? slot ?\\011\\011\\011# SKNET Personal/MC2+\n"
"_CFG_\n"
"_CFG_# MII/PHY support\n"
"_CFG_acphy*\\011at mii? phy ?\\011\\011\\011# DAltima AC101 and AMD Am79c874 PHYs\n"
"_CFG_amhphy*\\011at mii? phy ?\\011\\011\\011# AMD 79c901 Ethernet PHYs\n"
"_CFG_bmtphy*\\011at mii? phy ?\\011\\011\\011# Broadcom BCM5201 and BCM5202 PHYs\n"
"_CFG_brgphy*\\011at mii? phy ?\\011\\011\\011# Broadcom BCM5400-family PHYs\n"
"_CFG_dmphy*\\011at mii? phy ?\\011\\011\\011# Davicom DM9101 PHYs\n"
"_CFG_exphy*\\011at mii? phy ?\\011\\011\\011# 3Com internal PHYs\n"
"_CFG_glxtphy* at mii? phy ?\\011\\011\\011# Level One LXT-1000 PHYs\n"
"_CFG_gphyter* at mii? phy ?\\011\\011\\011# NS83861 Gig-E PHY\n"
"_CFG_icsphy*\\011at mii? phy ?\\011\\011\\011# Integrated Circuit Systems ICS189x\n"
"_CFG_inphy*\\011at mii? phy ?\\011\\011\\011# Intel 82555 PHYs\n"
"_CFG_iophy*\\011at mii? phy ?\\011\\011\\011# Intel 82553 PHYs\n"
"_CFG_lxtphy*\\011at mii? phy ?\\011\\011\\011# Level One LXT-970 PHYs\n"
"_CFG_makphy*\\011at mii? phy ?\\011\\011\\011# Marvell Semiconductor 88E1000 PHYs\n"
"_CFG_nsphy*\\011at mii? phy ?\\011\\011\\011# NS83840 PHYs\n"
"_CFG_nsphyter* at mii? phy ?\\011\\011\\011# NS83843 PHYs\n"
"_CFG_pnaphy*\\011at mii? phy ?\\011\\011\\011# generic HomePNA PHYs\n"
"_CFG_qsphy*\\011at mii? phy ?\\011\\011\\011# Quality Semiconductor QS6612 PHYs\n"
"_CFG_sqphy*\\011at mii? phy ?\\011\\011\\011# Seeq 80220/80221/80223 PHYs\n"
"_CFG_tlphy*\\011at mii? phy ?\\011\\011\\011# ThunderLAN PHYs\n"
"_CFG_tqphy*\\011at mii? phy ?\\011\\011\\011# TDK Semiconductor PHYs\n"
"_CFG_ukphy*\\011at mii? phy ?\\011\\011\\011# generic unknown PHYs\n"
"_CFG_urlphy* at mii? phy ?\\011\\011\\011# Realtek RTL8150L internal PHYs\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# USB Controller and Devices\n"
"_CFG_\n"
"_CFG_# PCI USB controllers\n"
"_CFG_# The EHCI is not ready for prime time.\n"
"_CFG_#ehci*\\011at pci?\\011dev ? function ?\\011# Enhanced Host Controller\n"
"_CFG_#ohci*\\011at pci?\\011dev ? function ?\\011# Open Host Controller\n"
"_CFG_uhci*\\011at pci?\\011dev ? function ?\\011# Universal Host Controller (Intel)\n"
"_CFG_\n"
"_CFG_# CardBus USB controllers\n"
"_CFG_#ehci*\\011at cardbus? dev ? function ?\\011# Enhanced Host Controller\n"
"_CFG_#ohci*\\011at cardbus? dev ? function ?\\011# Open Host Controller\n"
"_CFG_\n"
"_CFG_# ISA USB controllers\n"
"_CFG_#slhci0\\011at isa? port 0x300 irq 5\\011# ScanLogic SL811HS\n"
"_CFG_\n"
"_CFG_# USB bus support\n"
"_CFG_#usb*\\011at ehci?\n"
"_CFG_#usb*\\011at ohci?\n"
"_CFG_usb*\\011at uhci?\n"
"_CFG_#usb*\\011at slhci?\n"
"_CFG_\n"
"_CFG_# USB Hubs\n"
"_CFG_uhub*\\011at usb?\n"
"_CFG_uhub*\\011at uhub? port ? configuration ? interface ?\n"
"_CFG_\n"
"_CFG_# USB HID device\n"
"_CFG_uhidev*\\011at uhub? port ? configuration ? interface ?\n"
"_CFG_\n"
"_CFG_# USB Mice\n"
"_CFG_ums*\\011at uhidev? reportid ?\n"
"_CFG_wsmouse* at ums? mux 0\n"
"_CFG_\n"
"_CFG_# USB Keyboards\n"
"_CFG_ukbd*\\011at uhidev? reportid ?\n"
"_CFG_wskbd*\\011at ukbd? console ? mux 1\n"
"_CFG_\n"
"_CFG_# USB Generic HID devices\n"
"_CFG_uhid*\\011at uhidev? reportid ?\n"
"_CFG_\n"
"_CFG_# USB Printer\n"
"_CFG_ulpt*\\011at uhub? port ? configuration ? interface ?\n"
"_CFG_\n"
"_CFG_# USB Modem\n"
"_CFG_umodem*\\011at uhub? port ? configuration ?\n"
"_CFG_ucom*\\011at umodem?\n"
"_CFG_\n"
"_CFG_# USB Mass Storage\n"
"_CFG_umass*\\011at uhub? port ? configuration ? interface ?\n"
"_CFG_#wd* at umass?\n"
"_CFG_\n"
"_CFG_# USB audio\n"
"_CFG_uaudio*\\011at uhub? port ? configuration ?\n"
"_CFG_\n"
"_CFG_# USB MIDI\n"
"_CFG_umidi* at uhub? port ? configuration ?\n"
"_CFG_\n"
"_CFG_# USB IrDA\n"
"_CFG_# USB-IrDA bridge spec\n"
"_CFG_uirda* at uhub? port ? configuration ? interface ?\n"
"_CFG_irframe* at uirda?\n"
"_CFG_\n"
"_CFG_# SigmaTel STIr4200 USB/IrDA Bridge\n"
"_CFG_ustir* at uhub? port ?\n"
"_CFG_irframe* at ustir?\n"
"_CFG_\n"
"_CFG_# USB Ethernet adapters\n"
"_CFG_aue*\\011at uhub? port ?\\011\\011# ADMtek AN986 Pegasus based adapters\n"
"_CFG_cue*\\011at uhub? port ?\\011\\011# CATC USB-EL1201A based adapters\n"
"_CFG_kue*\\011at uhub? port ?\\011\\011# Kawasaki LSI KL5KUSB101B based adapters\n"
"_CFG_url*\\011at uhub? port ?\\011\\011# Realtek RTL8150L based adapters\n"
"_CFG_\n"
"_CFG_# Prolific PL2301/PL2302 host-to-host adapter\n"
"_CFG_upl*\\011at uhub? port ?\n"
"_CFG_\n"
"_CFG_# Serial adapters\n"
"_CFG_uftdi*\\011at uhub? port ?\\011\\011# FTDI FT8U100AX serial adapter\n"
"_CFG_ucom*\\011at uftdi? portno ?\n"
"_CFG_\n"
"_CFG_umct*\\011at uhub? port ?\\011\\011# MCT USB-RS232 serial adapter\n"
"_CFG_ucom*\\011at umct? portno ?\n"
"_CFG_\n"
"_CFG_uplcom*\\011at uhub? port ?\\011\\011# I/O DATA USB-RSAQ2 serial adapter\n"
"_CFG_ucom*\\011at uplcom? portno ?\n"
"_CFG_\n"
"_CFG_uvscom*\\011at uhub? port ?\\011\\011# SUNTAC Slipper U VS-10U serial adapter\n"
"_CFG_ucom*\\011at uvscom? portno ?\n"
"_CFG_\n"
"_CFG_# Diamond Multimedia Rio 500\n"
"_CFG_urio*\\011at uhub? port ?\n"
"_CFG_\n"
"_CFG_# USB Handspring Visor\n"
"_CFG_uvisor*\\011at uhub? port ?\n"
"_CFG_ucom*\\011at uvisor?\n"
"_CFG_\n"
"_CFG_# USB scanners\n"
"_CFG_uscanner* at uhub? port ?\n"
"_CFG_\n"
"_CFG_# USB scanners that use SCSI emulation, e.g., HP5300\n"
"_CFG_usscanner* at uhub? port ?\n"
"_CFG_\n"
"_CFG_# Y@P firmware loader\n"
"_CFG_uyap* at uhub? port ?\n"
"_CFG_\n"
"_CFG_# D-Link DSB-R100 USB radio\n"
"_CFG_udsbr*\\011at uhub? port ?\n"
"_CFG_radio*\\011at udsbr?\n"
"_CFG_\n"
"_CFG_# USB Generic driver\n"
"_CFG_ugen*\\011at uhub? port ?\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# IrDA and Consumer Ir devices\n"
"_CFG_\n"
"_CFG_# Toshiba Oboe\n"
"_CFG_#oboe* \\011at pci? dev ? function ?\n"
"_CFG_#irframe* at oboe?\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Audio Devices\n"
"_CFG_\n"
"_CFG_# PCI audio devices\n"
"_CFG_#auich*\\011at pci? dev ? function ?\\011# Intel ICH integrated AC'97 Audio\n"
"_CFG_#autri*\\011at pci? dev ? function ?\\011# Trident 4DWAVE based AC'97 Audio\n"
"_CFG_#auvia*\\011at pci? dev ? function ?\\011# VIA VT82C686A integrated AC'97 Audio\n"
"_CFG_#clcs*\\011at pci? dev ? function ?\\011# Cirrus Logic CS4280\n"
"_CFG_clct*\\011at pci? dev ? function ?\\011# Cirrus Logic CS4281\n"
"_CFG_#cmpci*\\011at pci? dev ? function ?\\011# C-Media CMI8338/8738\n"
"_CFG_#eap*\\011at pci? dev ? function ?\\011# Ensoniq AudioPCI\n"
"_CFG_#emuxki*\\011at pci? dev ? function ?\\011# Creative SBLive! and PCI512\n"
"_CFG_#esa*\\011at pci? dev ? function ?\\011# ESS Allegro-1 / Maestro-3 PCI Audio\n"
"_CFG_#esm*\\011at pci? dev ? function ?\\011# ESS Maestro-1/2/2e PCI Audio Accelerator\n"
"_CFG_#eso*\\011at pci? dev ? function ?\\011# ESS Solo-1 PCI AudioDrive\n"
"_CFG_#fms*\\011at pci? dev ? function ?\\011# Forte Media FM801\n"
"_CFG_#neo*\\011at pci? dev ? function ?\\011# NeoMagic 256 AC'97 Audio\n"
"_CFG_#sv*\\011at pci? dev ? function ?\\011# S3 SonicVibes\n"
"_CFG_#yds*\\011at pci? dev ? function ?\\011# Yamaha DS-1 PCI Audio\n"
"_CFG_\n"
"_CFG_# ISA Plug-and-Play audio devices\n"
"_CFG_#ess*\\011at isapnp?\\011\\011\\011# ESS Tech ES1887, ES1888, ES888 audio\n"
"_CFG_#guspnp*\\011at isapnp?\\011\\011\\011# Gravis Ultra Sound PnP audio\n"
"_CFG_#sb*\\011at isapnp?\\011\\011\\011# SoundBlaster-compatible audio\n"
"_CFG_#wss*\\011at isapnp?\\011\\011\\011# Windows Sound System\n"
"_CFG_#ym*\\011at isapnp?\\011\\011\\011# Yamaha OPL3-SA3 audio\n"
"_CFG_\n"
"_CFG_# ISA audio devices\n"
"_CFG_# the \"aria\" probe might give false hits\n"
"_CFG_#aria0\\011at isa? port 0x290 irq 10 \\011\\011# Aria\n"
"_CFG_#ess0\\011at isa? port 0x220 irq 5 drq 1 drq2 5\\011# ESS 18XX\n"
"_CFG_#gus0\\011at isa? port 0x220 irq 7 drq 1 drq2 6\\011# Gravis Ultra Sound\n"
"_CFG_#pas0\\011at isa? port 0x220 irq 7 drq 1\\011\\011# ProAudio Spectrum\n"
"_CFG_#pss0\\011at isa? port 0x220 irq 7 drq 6\\011\\011# Personal Sound System\n"
"_CFG_#sp0\\011at pss0 port 0x530 irq 10 drq 0\\011\\011# \\011sound port driver\n"
"_CFG_#sb0\\011at isa? port 0x220 irq 5 drq 1 drq2 5\\011# SoundBlaster\n"
"_CFG_#wss0\\011at isa? port 0x530 irq 10 drq 0\\011drq2 1\\011# Windows Sound System\n"
"_CFG_\n"
"_CFG_# PCMCIA audio devices\n"
"_CFG_#esl*\\011at pcmcia? function ?\\011\\011\\011# ESS 1688 AudioDrive\n"
"_CFG_\n"
"_CFG_#cms0\\011at isa? port 0x220\\011\\011\\011# Creative Music System\n"
"_CFG_\n"
"_CFG_# OPL[23] FM synthesizers\n"
"_CFG_#opl0\\011at isa? port 0x388\\011# use only if not attached to sound card\n"
"_CFG_#opl*\\011at cmpci? flags 1\n"
"_CFG_#opl*\\011at esl?\n"
"_CFG_#opl*\\011at eso?\n"
"_CFG_#opl*\\011at ess?\n"
"_CFG_#opl*\\011at fms?\n"
"_CFG_#opl*\\011at sb?\n"
"_CFG_#opl*\\011at sv?\n"
"_CFG_#opl*\\011at wss?\n"
"_CFG_#opl*\\011at yds?\n"
"_CFG_#opl*\\011at ym?\n"
"_CFG_\n"
"_CFG_# Audio support\n"
"_CFG_audio*\\011at audiobus?\n"
"_CFG_\n"
"_CFG_# MPU 401 UARTs\n"
"_CFG_#mpu*\\011at isa? port 0x330 irq 9\\011# MPU401 or compatible card\n"
"_CFG_#mpu*\\011at cmpci?\n"
"_CFG_#mpu*\\011at eso?\n"
"_CFG_#mpu*\\011at fms?\n"
"_CFG_#mpu*\\011at sb?\n"
"_CFG_#mpu*\\011at yds?\n"
"_CFG_#mpu*\\011at ym?\n"
"_CFG_\n"
"_CFG_# MIDI support\n"
"_CFG_midi*\\011at midibus?\n"
"_CFG_midi*\\011at pcppi?\\011\\011# MIDI interface to the PC speaker\n"
"_CFG_\n"
"_CFG_# The spkr driver provides a simple tone interface to the built in speaker.\n"
"_CFG_#spkr0\\011at pcppi?\\011\\011# PC speaker\n"
"_CFG_\n"
"_CFG_# Roland SCP-55\n"
"_CFG_#rscp*\\011at pcmcia? function ?\n"
"_CFG_#mpu*\\011at rscp?\n"
"_CFG_#wss*\\011at rscp?\n"
"_CFG_\n"
"_CFG_# FM-Radio devices\n"
"_CFG_# ISA radio devices\n"
"_CFG_#az0\\011at isa? port 0x350      # Aztech/PackardBell FM Radio Card\n"
"_CFG_#az1\\011at isa? port 0x358\n"
"_CFG_#rt0\\011at isa? port 0x20c      # AIMS Lab Radiotrack & compatible\n"
"_CFG_#rt1\\011at isa? port 0x284\n"
"_CFG_#rt2\\011at isa? port 0x30c\n"
"_CFG_#rt3\\011at isa? port 0x384\n"
"_CFG_#rtii0\\011at isa? port 0x20c      # AIMS Lab Radiotrack II FM Radio Card\n"
"_CFG_#rtii1\\011at isa? port 0x30c\n"
"_CFG_#sf2r0\\011at isa? port 0x384      # SoundForte RadioLink SF16-FMR2 FM Radio Card\n"
"_CFG_\n"
"_CFG_# PCI radio devices\n"
"_CFG_#gtp*\\011at pci? dev ? function ? # Guillemot Maxi Radio FM 2000 Radio Card\n"
"_CFG_\n"
"_CFG_# Radio support\n"
"_CFG_#radio*\\011at az?\n"
"_CFG_#radio*\\011at gtp?\n"
"_CFG_#radio*\\011at rt?\n"
"_CFG_#radio*\\011at rtii?\n"
"_CFG_#radio*\\011at sf2r?\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# TV cards\n"
"_CFG_\n"
"_CFG_# Brooktree 848/849/878/879 based TV cards\n"
"_CFG_#bktr* at pci? dev ? function ?\n"
"_CFG_#radio* at bktr?\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Mice\n"
"_CFG_\n"
"_CFG_# ISA busmice\n"
"_CFG_#lms0\\011at isa? port 0x23c irq 5\\011# Logitech bus mouse\n"
"_CFG_#lms1\\011at isa? port 0x238 irq 5\n"
"_CFG_#mms0\\011at isa? port 0x23c irq 5\\011# Microsoft InPort mouse\n"
"_CFG_#mms1\\011at isa? port 0x238 irq 5\n"
"_CFG_#wsmouse*\\011at lms? mux 0\n"
"_CFG_#wsmouse*\\011at mms? mux 0\n"
"_CFG_# backwards compatible versions\n"
"_CFG_#olms0\\011at isa? port 0x23c irq 5\\011# Logitech bus mouse\n"
"_CFG_#olms1\\011at isa? port 0x238 irq 5\n"
"_CFG_#omms0\\011at isa? port 0x23c irq 5\\011# Microsoft InPort mouse\n"
"_CFG_#omms1\\011at isa? port 0x238 irq 5\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Joysticks\n"
"_CFG_\n"
"_CFG_#joy*\\011\\011at pnpbios? index ?\\011# Game port\n"
"_CFG_\n"
"_CFG_# ISA Plug-and-Play joysticks\n"
"_CFG_#joy*\\011at isapnp?\\011\\011\\011# Game ports (usually on audio cards)\n"
"_CFG_\n"
"_CFG_# PCI joysticks\n"
"_CFG_#joy*\\011at pci?\\011\\011\\011\\011# Game ports (usually on audio cards)\n"
"_CFG_#joy*\\011at eso?\\011\\011\\011\\011# ESS Solo-1 on-board joystick\n"
"_CFG_\n"
"_CFG_# ISA joysticks. Probe is a little strange; add only if you have one.\n"
"_CFG_#joy0\\011at isa? port 0x201\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Miscellaneous Devices\n"
"_CFG_\n"
"_CFG_# Planetconnect Satellite receiver driver.\n"
"_CFG_#satlink0 at isa? port 0x300 drq 1\n"
"_CFG_\n"
"_CFG_# Middle Digital, Inc. PCI-Weasel serial console board control\n"
"_CFG_# devices (watchdog timer, etc.)\n"
"_CFG_#weasel* at pci?\n"
"_CFG_\n"
"_CFG_# Pull in optional local configuration\n"
"_CFG_include\\011\"arch/i386/conf/GENERIC.local\"\n"
"_CFG_\n"
"_CFG_\n"
"_CFG_# Pseudo-Devices\n"
"_CFG_\n"
"_CFG_# disk/mass storage pseudo-devices\n"
"_CFG_#pseudo-device\\011ccd\\011\\0114\\011# concatenated/striped disk devices\n"
"_CFG_# RAIDframe is broken with MULTIPROCESSOR / LOCKDEBUG\n"
"_CFG_#pseudo-device\\011raid\\011\\0118\\011# RAIDframe disk driver\n"
"_CFG_#options \\011RAID_AUTOCONFIG\\011\\011# auto-configuration of RAID components\n"
"_CFG_#Options to enable various other RAIDframe RAID types.\n"
"_CFG_#options \\011RF_INCLUDE_EVENODD=1\n"
"_CFG_#options \\011RF_INCLUDE_RAID5_RS=1\n"
"_CFG_#options \\011RF_INCLUDE_PARITYLOGGING=1\n"
"_CFG_#options \\011RF_INCLUDE_CHAINDECLUSTER=1\n"
"_CFG_#options \\011RF_INCLUDE_INTERDECLUSTER=1\n"
"_CFG_#options \\011RF_INCLUDE_PARITY_DECLUSTERING=1\n"
"_CFG_#options \\011RF_INCLUDE_PARITY_DECLUSTERING_DS=1\n"
"_CFG_\n"
"_CFG_#pseudo-device\\011md\\011\\0111\\011# memory disk device (ramdisk)\n"
"_CFG_pseudo-device\\011vnd\\011\\0114\\011# disk-like interface to files\n"
"_CFG_\n"
"_CFG_# network pseudo-devices\n"
"_CFG_pseudo-device\\011bpfilter\\01116\\011# Berkeley packet filter\n"
"_CFG_pseudo-device\\011ipfilter\\011\\011# IP filter (firewall) and NAT\n"
"_CFG_pseudo-device\\011loop\\011\\011\\011# network loopback\n"
"_CFG_pseudo-device\\011ppp\\011\\0111\\011# Point-to-Point Protocol\n"
"_CFG_pseudo-device\\011pppoe\\011\\011\\011# PPP over Ethernet (RFC 2516)\n"
"_CFG_pseudo-device\\011sl\\011\\0111\\011# Serial Line IP\n"
"_CFG_#pseudo-device\\011strip\\011\\0111\\011# Starmode Radio IP (Metricom)\n"
"_CFG_#pseudo-device\\011irframetty\\011\\011# IrDA frame line discipline\n"
"_CFG_pseudo-device\\011tun\\011\\0111\\011# network tunneling over tty\n"
"_CFG_pseudo-device\\011gre\\011\\0112\\011# generic L3 over IP tunnel\n"
"_CFG_pseudo-device\\011gif\\011\\0114\\011# IPv[46] over IPv[46] tunnel (RFC1933)\n"
"_CFG_#pseudo-device\\011faith\\011\\0111\\011# IPv[46] tcp relay translation i/f\n"
"_CFG_#pseudo-device\\011stf\\011\\0111\\011# 6to4 IPv6 over IPv4 encapsulation\n"
"_CFG_pseudo-device\\011vlan\\011\\011\\011# IEEE 802.1q encapsulation\n"
"_CFG_pseudo-device\\011bridge\\011\\011\\011# simple inter-network bridging\n"
"_CFG_\n"
"_CFG_# miscellaneous pseudo-devices\n"
"_CFG_pseudo-device\\011pty\\011\\011\\011# pseudo-terminals\n"
"_CFG_#pseudo-device\\011tb\\011\\0111\\011# tablet line discipline\n"
"_CFG_pseudo-device\\011sequencer\\0111\\011# MIDI sequencer\n"
"_CFG_# rnd works; RND_COM does not on port i386 yet.\n"
"_CFG_pseudo-device\\011rnd\\011\\011\\011# /dev/random and in-kernel generator\n"
"_CFG_#options \\011RND_COM\\011\\011\\011# use \"com\" randomness as well (BROKEN)\n"
"_CFG_pseudo-device\\011clockctl\\011\\011# user control of clock subsystem\n"
"_CFG_\n"
"_CFG_# a pseudo device needed for Coda\\011# also needs CODA (above)\n"
"_CFG_#pseudo-device\\011vcoda\\011\\0114\\011# coda minicache <-> venus comm.\n"
"_CFG_\n"
"_CFG_# wscons pseudo-devices\n"
"_CFG_pseudo-device\\011wsmux\\011\\011\\011# mouse & keyboard multiplexor\n"
"_CFG_pseudo-device\\011wsfont\n"
#ifdef INCLUDE_CONFIG_FILE

"_CFG_### END CONFIG FILE \"KOHARU\"\n"
"_CFG_### (included from \"arch/pcat/conf/std.pcat\")\n"
"_CFG_###> # $NetBSD$\n"
"_CFG_###> #\n"
"_CFG_###> # standard, required NetBSD/pcat 'options'\n"
"_CFG_###> \n"
"_CFG_###> machine pcat i386\n"
"_CFG_###> \n"
"_CFG_###> options \\011EXEC_AOUT\\011# exec a.out binaries\n"
"_CFG_###> options \\011EXEC_ELF32\\011# exec ELF binaries\n"
"_CFG_###> options \\011EXEC_SCRIPT\\011# exec #! scripts\n"
"_CFG_###> \n"
"_CFG_###> options \\011INET6_MD_CKSUM\\011# machine-dependant code for in6_cksum\n"
"_CFG_###> #options \\011CRYPTO_MD_DES_ENC\\011# machine-dependant code for DES\n"
"_CFG_###> #options \\011CRYPTO_MD_DES_CBC\\011# machine-dependant DES CBC code\n"
"_CFG_###> #options \\011CRYPTO_MD_BF_ENC\\011# machine-dependant code for BF_encrypt\n"
"_CFG_###> #options \\011CRYPTO_MD_BF_CBC\\011# careful: uses bswapl, requires 486\n"
"_CFG_### (end include \"arch/pcat/conf/std.pcat\")\n"
"_CFG_### (included from \"arch/i386/conf/GENERIC.local\")\n"
"_CFG_###> #\\011$NetBSD: GENERIC.local,v 1.1 1996/09/09 16:37:08 mycroft Exp $\n"
"_CFG_###> #\n"
"_CFG_###> #\\011GENERIC.local -- local additions to the GENERIC configuration\n"
"_CFG_###> #\n"
"_CFG_###> \n"
"_CFG_### (end include \"arch/i386/conf/GENERIC.local\")\n"
#endif /* INCLUDE_CONFIG_FILE */
;
#endif /* INCLUDE_CONFIG_FILE || INCLUDE_JUST_CONFIG */
#endif /* CONFIG_FILE */
